<?php
/* admin/agi_export.php
.---------------------------------------------------------------------------.
|    Software: agi_export for modified eCommerce                            |
|      Author: Andreas Guder                                                |
|     Contact: info@andreas-guder.de                                        |
| Copyright (c) 2022, Andreas Guder [info@andreas-guder.de]                 |
|               All Rights Reserved.                                        |
| ------------------------------------------------------------------------- |
|     License: you are not allowed to distribute                            |
|              or sublicense copies of the software without                 |
|              a grant of a licence of the coyright-owner                   |
'---------------------------------------------------------------------------ü
*/

require('includes/application_top.php');
error_reportinG(E_ALL);
ini_set('display_errors','on');
// include needed classes and functions
require DIR_FS_EXTERNAL.'agi/agi_export/admin/functions.php';

$_agi_submodul = '';
if (isset($_GET['sub']) && preg_match('/^\w{3,25}$/', $_GET['sub'])) {
  $_agi_submodul = $_GET['sub'];
}

if (!empty($_agi_submodul) && is_file(DIR_FS_EXTERNAL.'agi/agi_export/admin/modules/'.$_agi_submodul.'/module.php')) { 
  require DIR_FS_EXTERNAL.'agi/agi_export/admin/modules/'.$_agi_submodul.'/module.php';
}

require (DIR_WS_INCLUDES.'head.php');
?>
</head>
<body>
    <!-- header //-->
    <?php require(DIR_WS_INCLUDES . 'header.php'); ?>
    <!-- header_eof //-->

    <!-- body //-->
    <div style="max-width:1224px;margin:0 auto;">
    <table class="tableBody">
      <tr>
        <?php //left_navigation
        if (USE_ADMIN_TOP_MENU == 'false') {
          echo '<td class="columnLeft2">'.PHP_EOL;
          echo '<!-- left_navigation //-->'.PHP_EOL;       
          require_once(DIR_WS_INCLUDES . 'column_left.php');
          echo '<!-- left_navigation eof //-->'.PHP_EOL; 
          echo '</td>'.PHP_EOL;      
        }
        ?>
        <!-- body_text //-->
        <td class="boxCenter">
          <div class="pageHeadingImage"><?php echo xtc_image(DIR_WS_ICONS.'heading/icon_configuration.png'); ?></div>
          <div class="flt-l">
            <div class="pageHeading pdg2"><?php echo MODULE_SYSTEM_AGI_EXPORT_TITLE; ?></div>
            <div class="main">v<?php echo agi_export_get_config('version'); ?> - - - <a href="https://www.andreas-guder.de/" target="_blank">www.andreas-guder.de</a></div>
          </div>
          <div class="clear mrg5" style="margin-top:-1px;">
          <?php 
            require DIR_FS_EXTERNAL.'agi/agi_export/admin/modules_navigation.php';

            if (!empty($_agi_submodul) && is_file(DIR_FS_EXTERNAL.'agi/agi_export/admin/modules/'.$_agi_submodul.'/template.php')) { 
              require DIR_FS_EXTERNAL.'agi/agi_export/admin/modules/'.$_agi_submodul.'/template.php';
            }
            if (empty($_agi_submodul)) {
              require DIR_FS_EXTERNAL.'agi/agi_export/admin/modules/info/template.php';
            }
          ?>
          </div>
        </td>
        <!-- body_text_eof //-->
      </tr>
    </table>
    </div>
    <!-- body_eof //-->
    <!-- footer //-->
    <?php require(DIR_WS_INCLUDES . 'footer.php'); ?>
    <!-- footer_eof //-->
  </body>
</html>
<?php require(DIR_WS_INCLUDES . 'application_bottom.php'); ?>