<?php
/* admin/includes/modules/categories/agi_export.php
.---------------------------------------------------------------------------.
|    Software: agi_export for modified eCommerce                            |
|      Author: Andreas Guder                                                |
|     Contact: info@andreas-guder.de                                        |
| Copyright (c) 2022, Andreas Guder [info@andreas-guder.de]                 |
|               All Rights Reserved.                                        |
| ------------------------------------------------------------------------- |
|     License: you are not allowed to distribute                            |
|              or sublicense copies of the software without                 |
|              a grant of a licence of the coyright-owner                   |
'---------------------------------------------------------------------------ü
*/
defined( '_VALID_XTC' ) or die( 'Direct Access to this location is not allowed.' );

if (!defined('MODULE_CATEGORIES_AGI_EXPORT_TITLE')) {
  if (file_exists(DIR_FS_CATALOG . 'lang/' . $_SESSION['language'] . '/modules/categories/agi_export.php')) {
    include_once(DIR_FS_CATALOG . 'lang/' . $_SESSION['language'] . '/modules/categories/agi_export.php');
  }
}

class agi_export {
  var $code, $name, $title, $description, $enabled, $sort_order, $_check;
  function __construct() 
  {
    $this->code = 'agi_export';
    $this->name = 'MODULE_CATEGORIES_'.strtoupper($this->code);
    $this->title = defined($this->name.'_TITLE') ? constant($this->name.'_TITLE') : '';
    $this->description = defined($this->name.'_DESCRIPTION') ? constant($this->name.'_DESCRIPTION') : '';
    $this->enabled = defined($this->name.'_STATUS') && constant($this->name.'_STATUS') == 'true' ? true : false;
    $this->sort_order = defined($this->name.'_SORT_ORDER') ? constant($this->name.'_SORT_ORDER') : '';
  }
  function custom() {}
  
  function check()
  {
    if (!isset($this->_check)) {
      $check_query = xtc_db_query("SELECT configuration_value 
                                     FROM " . TABLE_CONFIGURATION . " 
                                    WHERE configuration_key = '".$this->name."_STATUS'");
      $this->_check = xtc_db_num_rows($check_query);
    }
    return $this->_check;
  }

  function keys()
  {
    defined($this->name.'_STATUS_TITLE') OR define($this->name.'_STATUS_TITLE', TEXT_DEFAULT_STATUS_TITLE);
    defined($this->name.'_STATUS_DESC') OR define($this->name.'_STATUS_DESC', TEXT_DEFAULT_STATUS_DESC);
    defined($this->name.'_SORT_ORDER_TITLE') OR define($this->name.'_SORT_ORDER_TITLE', TEXT_DEFAULT_SORT_ORDER_TITLE);
    defined($this->name.'_SORT_ORDER_DESC') OR define($this->name.'_SORT_ORDER_DESC', TEXT_DEFAULT_SORT_ORDER_DESC);
  
    $keys = array(
      $this->name.'_STATUS'
    );
  
    return $keys;
  }

  function install()
  {
    xtc_db_query("INSERT INTO " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, date_added) VALUES ('".$this->name."_STATUS', 'true','6', '1','xtc_cfg_select_option(array(\'true\', \'false\'), ', now())");
    xtc_db_query("INSERT INTO " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added) VALUES ('".$this->name."_SORT_ORDER', '10','6', '2', now())");
    
    xtc_redirect(xtc_href_link(FILENAME_MODULE_EXPORT, 'set=system&module=agi_export'));
  }
  
  function remove() {  
    xtc_db_query("DELETE FROM " . TABLE_CONFIGURATION . " WHERE configuration_key LIKE '".$this->name."_%'");
    xtc_redirect(xtc_href_link(FILENAME_MODULE_EXPORT, 'set=system&module=agi_export'));
  }


  //--- BEGIN CUSTOM  CLASS METHODS ---//
  /*
  function remove_product($products_id) 
  {
    return $products_id;
  }
  */
  function insert_product_after($products_data, $products_id)
  {
    $agi_export_image_json = array();
    $qr = "SELECT IFNULL(`products_image`,'') AS products_image FROM `".TABLE_PRODUCTS."` WHERE `products_id`='".(int)$products_id."'";
    $q_result = xtc_db_query($qr);
    $q_data = xtc_db_fetch_array($q_result);
    if (!empty($q_data['products_image'])) {
      $agi_export_image_json[0] = array(
        'export'    => $products_data['agi_exportimage_active_0'],
        'sortorder' => $products_data['agi_exportimage_sortorder_0']
      );
      if (array_key_exists('agi_exportimage_attribute_0', $products_data)) {
        $tmp = $this->agi_export_get_image_attributes_array($products_data['agi_exportimage_attribute_0']);
        if (!empty($tmp)) {
          $agi_export_image_json[0]['attributes'] = $tmp;
        }
      }
    }
    if (defined('TABLE_PRODUCTS_IMAGES') && defined('MO_PICS')) {
      $qr = "SELECT `image_nr` FROM `" . TABLE_PRODUCTS_IMAGES . "` WHERE `products_id` = ".(int)$products_id." ORDER BY image_nr";
      $q_result = xtc_db_query($qr);
      while ($q_data = xtc_db_fetch_array($q_result)) {
        $agi_export_image_json[$q_data['image_nr']] = array(
          'export'    => array_key_exists('agi_exportimage_active_'.$q_data['image_nr'], $products_data) ? $products_data['agi_exportimage_active_'.$q_data['image_nr']] : 0,
          'sortorder' => array_key_exists('agi_exportimage_sortorder_'.$q_data['image_nr'], $products_data) ? $products_data['agi_exportimage_sortorder_'.$q_data['image_nr']] : 0
        );
        if (array_key_exists('agi_exportimage_attribute_'.$q_data['image_nr'], $products_data)) {
          $tmp = $this->agi_export_get_image_attributes_array($products_data['agi_exportimage_attribute_'.$q_data['image_nr']]);
          if (!empty($tmp)) {
            $agi_export_image_json[$q_data['image_nr']]['attributes'] = $tmp;
          }
        }
      }
    }
    
    $sql_data = array('agi_export_image_json' => empty($agi_export_image_json) ? '' : json_encode($agi_export_image_json, JSON_FORCE_OBJECT | JSON_UNESCAPED_UNICODE));
    $sql_data['agi_google_excluded_destination'] = '';
    if (array_key_exists('agi_export_google_destination_exclude', $products_data) && is_array($products_data['agi_export_google_destination_exclude'])) {
      $tmp = array();
      foreach ($products_data['agi_export_google_destination_exclude'] as $row) {
        if (!empty($row)) {
          $tmp[] = $row;
        }
      }
      if (!empty($tmp)) {
        $sql_data['agi_google_excluded_destination'] = implode(',', $tmp);
      }
    }
    $sql_data['agi_google_included_destination'] = '';
    if (array_key_exists('agi_export_google_destination_include', $products_data) && is_array($products_data['agi_export_google_destination_include'])) {
      $tmp = array();
      foreach ($products_data['agi_export_google_destination_include'] as $row) {
        if (!empty($row)) {
          $tmp[] = $row;
        }
      }
      if (!empty($tmp)) {
        $sql_data['agi_google_included_destination'] = implode(',', $tmp);
      }
    }
    
    $qr = xtc_db_query("SELECT `id`,`input_fields` FROM `agi_export_feeds`");
    while ($row = xtc_db_fetch_array($qr)) {
      $sql_data['agi_export_feed_'.$row['id']] = array_key_exists('agi_export_feed_'.$row['id'], $products_data) ? $products_data['agi_export_feed_'.$row['id']] : 0;
      // input_fields
      $input_fields_values = array();
      if (!empty($row['input_fields']) && array_key_exists('agi_export_feed_'.$row['id'].'_inputs', $products_data) && !empty($products_data['agi_export_feed_'.$row['id'].'_inputs'])) {
        $input_fields = json_decode($row['input_fields'], true);
        foreach ($input_fields as $field_data) {
          if (array_key_exists($field_data['key'], $products_data['agi_export_feed_'.$row['id'].'_inputs'])) {
            $tmp = preg_replace('/\s/', '', $products_data['agi_export_feed_'.$row['id'].'_inputs'][$field_data['key']]);
            if ($tmp != '') {
              $input_fields_values[$field_data['key']] = encode_utf8($products_data['agi_export_feed_'.$row['id'].'_inputs'][$field_data['key']], '', true);
            }
          }
        }
      }
      $sql_data['agi_export_feed_'.$row['id'].'_inputs'] = empty($input_fields_values) ? '' : json_encode($input_fields_values, JSON_UNESCAPED_UNICODE);
    }
    xtc_db_perform(TABLE_PRODUCTS, $sql_data, 'update', "`products_id`=$products_id");
    return $products_data;
  }
  /*
  function duplicate_product_after($sql_data_array, $src_products_id, $dest_categories_id, $dup_products_id)
  {
    return $sql_data_array;
  }
  
  function insert_product_end($products_id)
  {
    return $products_id;
  }
  
  function remove_category($category_id)
  {
    return $category_id;
  }
  
  function insert_category_after($categories_data, $categories_id)
  {
    return $categories_data;
  }
  */
  
  // my personal funtions
  function agi_export_get_image_attributes_array($products_image_data)
  {
    if (is_array($products_image_data)) {
      $result = array();
      foreach ($products_image_data as $value) {
        if (!empty($value)) {
          $data = explode(':',$value);
          if (count($data) == 2 && !empty($data[0])) {
            $result[] = array('o'=>$data[0], 'v'=>$data[1] == 'all' ? 0 : $data[1]);
          }
        }
      }
      return $result;
    }
    return array();
  }
  
  function agi_export_load_products_attributes($products_id, $language_id)
  {
    if (!defined('MODULE_SYSTEM_AGI_EXPORT_STATUS') || empty($products_id)) {
      return array();
    }
    $qr = "SELECT `options_id`, `options_values_id` FROM `".TABLE_PRODUCTS_ATTRIBUTES."` WHERE `products_id`=".(int)$products_id." ORDER BY `sortorder`";
    $q_result = xtc_db_query($qr);
    $tmp_shown_options = array();
    $tmp_shown_options_values = array();
    $agi_product_attributes = array();
    while ($row = xtc_db_fetch_array($q_result)) {
      $tmp_shown_options[] = $row['options_id'];
      $tmp_shown_options_values[] = $row['options_values_id'];
      $agi_product_attributes[] = array('options_id'=> $row['options_id'], 'options_values_id'=> $row['options_values_id']);
    }
    if (!empty($agi_product_attributes)) {
      $qr = "SELECT `products_options_id`, `products_options_name` FROM `".TABLE_PRODUCTS_OPTIONS."` WHERE `products_options_id` IN (".implode(',',$tmp_shown_options).") AND `language_id`=".(int)$language_id." ORDER BY `products_options_sortorder`";
      $q_result = xtc_db_query($qr);
      $agi_shown_options = array();
      while($row = xtc_db_fetch_array($q_result)) {
        $agi_shown_options[$row['products_options_id']] = array('options_id'=>$row['products_options_id'], 'name'=>$row['products_options_name'], 'values'=> array());
        $agi_shown_options[$row['products_options_id']]['values'][] = array('id' => '', 'text'=>MODULE_CATEGORIES_AGI_EXPORT_NO_IMAGE_ATTRIBUTES);
        $agi_shown_options[$row['products_options_id']]['values'][] = array('id' => $row['products_options_id'].':all', 'text'=>MODULE_CATEGORIES_AGI_EXPORT_ALL_IMAGE_ATTRIBUTES);
      }
      if (empty($agi_shown_options)) {
        $qr = "SELECT MIN(`language_id`) AS minid FROM `".TABLE_PRODUCTS_OPTIONS."`";
        $q_result = xtc_db_fetch_array(xtc_db_query($qr));
        $language_id = $q_result['minid'];
        
        $qr = "SELECT `products_options_id`, `products_options_name` FROM `".TABLE_PRODUCTS_OPTIONS."` WHERE `products_options_id` IN (".implode(',',$tmp_shown_options).") AND `language_id`=".(int)$language_id." ORDER BY `products_options_sortorder`";
        $q_result = xtc_db_query($qr);
        $agi_shown_options = array();
        while($row = xtc_db_fetch_array($q_result)) {
          $agi_shown_options[$key] = array('options_id'=>$row['products_options_id'], 'name'=>$row['products_options_name'], 'values'=> array());
          $agi_shown_options[$key]['values'][] = array('id' => '', 'text'=>MODULE_CATEGORIES_AGI_EXPORT_NO_IMAGE_ATTRIBUTES);
          $agi_shown_options[$key]['values'][] = array('id' => $row['products_options_id'].':all', 'text'=>MODULE_CATEGORIES_AGI_EXPORT_ALL_IMAGE_ATTRIBUTES);
        }
      }
      $qr = "SELECT `products_options_values_id`, `products_options_values_name` FROM `".TABLE_PRODUCTS_OPTIONS_VALUES."` WHERE `products_options_values_id` IN (".implode(',',$tmp_shown_options_values).") AND `language_id`=".(int)$language_id;
      $q_result = xtc_db_query($qr);
      $agi_option_values = array();
      while($row = xtc_db_fetch_array($q_result)) {
        $agi_option_values[$row['products_options_values_id']] = $row['products_options_values_name'];
      }
      foreach ($agi_product_attributes as $row) {
        if (array_key_exists($row['options_id'], $agi_shown_options) && array_key_exists($row['options_values_id'], $agi_option_values)) {
          $agi_shown_options[$row['options_id']]['values'][] = array('id'=>$row['options_id'].':'.$row['options_values_id'], 'text'=>$agi_option_values[$row['options_values_id']]);
        }
      }
      return $agi_shown_options;
    }
    return array();
  }
  
  function agi_export_get_products_image_attribute_selection($products_attributes, $agi_export_image_json = '', $image_id = 0)
  {
    if (!defined('MODULE_SYSTEM_AGI_EXPORT_STATUS')) {
      return '';
    }
    $image_options = array();
    if (!empty($agi_export_image_json)) {
      $json = json_decode($agi_export_image_json, true);
      if (array_key_exists($image_id, $json)) {
        if (array_key_exists('attributes', $json[$image_id])) {
          foreach ($json[$image_id]['attributes'] as $row) {
            $image_options[$row['o']] = empty($row['v']) ? $row['o'].':all' : $row['o'].':'.$row['v'];
          }
        }
      }
    }
    
    $output = '<table summary="Attribute zum Bild" border="0"><tbody>';
    foreach ($products_attributes as $option_id => $option_data) {
      $output .= '<tr><td class="main">';
      $output .= encode_htmlentities($option_data['name']);
      $output .= '</td><td>';
      $output .= xtc_draw_pull_down_menu('agi_exportimage_attribute_'.$image_id.'[]', $option_data['values'], array_key_exists($option_id, $image_options) ? $image_options[$option_id] : '');
      $output .= '</td></tr>';
    }
    $output .= '</tbody></table>';
    return $output;
  }
  
  function agi_export_get_products_image_export_allowed($agi_export_image_json = '', $image_id = 0)
  {
    if (!defined('MODULE_SYSTEM_AGI_EXPORT_STATUS') || empty($agi_export_image_json)) {
      return true;
    }
    $json = json_decode($agi_export_image_json, true);
    if (!array_key_exists($image_id, $json)) {
      return true;
    }
    if (!array_key_exists('export', $json[$image_id])) {
      return false;
    }
    return $json[$image_id]['export'];
  }
  
  function agi_export_get_products_image_export_sortorder($agi_export_image_json = '', $image_id = 0)
  {
    if (!defined('MODULE_SYSTEM_AGI_EXPORT_STATUS') || empty($agi_export_image_json)) {
      return false;
    }
    $json = json_decode($agi_export_image_json, true);
    if (!array_key_exists($image_id, $json)) {
      return 0;
    }
    if (!array_key_exists('sortorder', $json[$image_id])) {
      return 0;
    }
    return $json[$image_id]['sortorder'];
  }
  
}
