<?php
/* admin/includes/modules/system/agi_export.php
.---------------------------------------------------------------------------.
|    Software: agi_export for modified eCommerce                            |
|      Author: Andreas Guder                                                |
|     Contact: info@andreas-guder.de                                        |
| Copyright (c) 2022, Andreas Guder [info@andreas-guder.de]                 |
|               All Rights Reserved.                                        |
| ------------------------------------------------------------------------- |
|     License: you are not allowed to distribute                            |
|              or sublicense copies of the software without                 |
|              a grant of a licence of the coyright-owner                   |
'---------------------------------------------------------------------------ü
*/
defined( '_VALID_XTC' ) or die( 'Direct Access to this location is not allowed.' );

if (!defined('MODULE_SYSTEM_AGI_EXPORT_TITLE')) {
  if (file_exists(DIR_FS_CATALOG . 'lang/' . $_SESSION['language'] . '/modules/system/agi_export.php')) {
    include_once(DIR_FS_CATALOG . 'lang/' . $_SESSION['language'] . '/modules/system/agi_export.php');
  }
}

class agi_export {
  var $code, $name, $title, $description, $enabled, $sort_order, $_check;
  public function __construct() {
    $this->code = 'agi_export'; //Important same name as class name
    $this->name = 'MODULE_SYSTEM_'.strtoupper($this->code);
    $this->title = constant($this->name.'_TITLE');
    $this->description = constant($this->name.'_DESCRIPTION');
    if (!file_exists(DIR_FS_ADMIN.'includes/modules/categories/agi_export.php')) {
      $this->description .= '<p style="font-weight:bold;color:#ff0000">Eine Installation ist nicht m&ouml;glich. Es fehlt diese Datei auf Ihrem Server:<br />'.DIR_ADMIN.'includes/modules/categories/agi_export.php</p>';
    }
    if (!is_writable(DIR_FS_EXTERNAL.'agi/agi_export/feeds/')) {
      if (@chmod(DIR_FS_EXTERNAL.'agi/agi_export/feeds/', 0775) && !is_writable(DIR_FS_EXTERNAL.'agi/agi_export/feeds/')) {
        $this->description .= '<p style="font-weight:bold;color:#ff0000">Eine Installation ist nicht m&ouml;glich. Das Feed-Verzeichnis ist nicht beschreibbar:<br />'.DIR_FS_EXTERNAL.'agi/agi_export/feeds/</p>';
      }
    }
    $this->enabled = defined($this->name.'_STATUS') && strtolower(constant($this->name.'_STATUS')) == 'true' ? true : false;
    $this->sort_order = defined($this->name.'_SORT_ORDER') ? constant($this->name.'_SORT_ORDER') : '';
  //$this->keys_dispnone = array($this->name.'_DELETE_DATA_ON_UNINSTALL');
  }
    
  function process($file='')
  {
  }

  function display()
  {
    $txt = '<br /><div align="center">' . xtc_button(BUTTON_SAVE) . xtc_button_link(BUTTON_CANCEL, xtc_href_link(FILENAME_MODULE_EXPORT, 'set=' . $_GET['set'] . '&module='.$this->code)) . "</div>";
    
    // check updates
    $updates_done = $this->_internal_updates();
    if ($updates_done) {
      $txt .= '<p style="background-color:#cdd7b3;margin-top:15px">Das Modul wurde auf die neuste Version aktualisiert.</p>';
    }
    return array('text' => $txt);
  }
  
  function check() 
  {
    if (!isset($this->_check)) {
      $check_query = xtc_db_query("SELECT configuration_value 
                                    FROM " . TABLE_CONFIGURATION . "
                                    WHERE configuration_key = '".$this->name."_STATUS'");
      $this->_check = xtc_db_num_rows($check_query);
    }
    return $this->_check;
  }
  
  function install() 
  {
    if (!defined($this->name.'_STATUS')) {
      xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('".$this->name."_STATUS', 'true', '6', '1', 'xtc_cfg_select_option(array(\'true\', \'false\'), ', now())");
      xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('".$this->name."_UNINSTALL_DATA', 'false', '6', '2', 'xtc_cfg_select_option(array(\'true\', \'false\'), ', now())");
    }
    
    $q = "CREATE TABLE IF NOT EXISTS `agi_export_config` (
      `config_key` varchar(128) NOT NULL,
      `config_group` varchar(64) NOT NULL DEFAULT 'base',
      `config_value` text NOT NULL,
      `preset` text NOT NULL,
      `configured` tinyint(1) NOT NULL DEFAULT 0,
      PRIMARY KEY (`config_key`),
      KEY `idx_config_group` (`config_group`)
    ) ENGINE=MyISAM;";
    xtc_db_query($q);
        
    $q = "CREATE TABLE IF NOT EXISTS `agi_export_cmp_addlink` (
      `campaigns_id` int(11) NOT NULL AUTO_INCREMENT,
      `campaigns_name` varchar(64) NOT NULL DEFAULT '',
      `campaigns_uripams` varchar(255) DEFAULT NULL,
      `date_added` datetime DEFAULT NULL,
      `last_modified` datetime DEFAULT NULL,
      PRIMARY KEY (`campaigns_id`),
      KEY `idx_campaigns_name` (`campaigns_name`)
    ) ENGINE=MyISAM AUTO_INCREMENT=1;";
    xtc_db_query($q);
    
    $q = "CREATE TABLE IF NOT EXISTS `agi_export_feeds` (
      `id` INT(11) NOT NULL AUTO_INCREMENT,
      `name` VARCHAR(128) NOT NULL DEFAULT '',
      `file_name` VARCHAR(128) NOT NULL DEFAULT '',
      `description` VARCHAR(512) NOT NULL DEFAULT '',
      `status` TINYINT(1) NOT NULL DEFAULT 1,
      `type` VARCHAR(32) NOT NULL DEFAULT 'google_xml',
      `cron` TINYINT(1) NOT NULL DEFAULT 1,
      `export_allowed` TINYINT(1) NOT NULL DEFAULT 1,
      `export_attributes` TINYINT(1) NOT NULL DEFAULT 1,
      `language` TINYINT(2) NOT NULL DEFAULT 2,
      `country` VARCHAR(64) NOT NULL DEFAULT 'DE',
      `zone` INT(3) NOT NULL DEFAULT '0',
      `customers_group` INT(3) NOT NULL DEFAULT '".DEFAULT_CUSTOMERS_STATUS_ID_GUEST."',
      `currency` VARCHAR(32) NOT NULL DEFAULT '',
      `campaign` INT(3) NOT NULL DEFAULT '0',
      `products_filter` TEXT NOT NULL,
      `csv_fields` TEXT NOT NULL,
      `csv_settings` TEXT NOT NULL,
      `google_settings` TEXT NOT NULL,
      `input_fields` TEXT NOT NULL,
      `date_added` datetime DEFAULT NULL,
      `last_modified` datetime DEFAULT NULL,
      `in_process` datetime DEFAULT '0000-00-00 00:00:00',
      `cron_last_pid` INT(11) NOT NULL DEFAULT 0,
      `cron_error_cnt` INT(11) NOT NULL DEFAULT 0,
      `quick_in_process` datetime DEFAULT '0000-00-00 00:00:00',
      `quick_cron_last_pid` INT(11) NOT NULL DEFAULT 0,
      `quick_cron_error_cnt` INT(11) NOT NULL DEFAULT 0,
      `clear_after_process` TINYINT(1) NOT NULL DEFAULT 0,
      PRIMARY KEY (`id`)
    ) ENGINE=MyISAM";
    xtc_db_query($q);
    
    $q = "CREATE TABLE IF NOT EXISTS `agi_export_catonoff` (
      `feed` INT(11) NOT NULL,
      `category` INT(11) NOT NULL,
      `preselect` CHAR(1) NOT NULL DEFAULT 'n',
      KEY `idx_feed` (`feed`),
      KEY `idx_category` (`category`)
    ) ENGINE=MyISAM";
    xtc_db_query($q);
    
    // INSERT first Feed
    $qr = xtc_db_query("SELECT `id` FROM `agi_export_feeds` WHERE `id`='1'");
    if (!xtc_db_num_rows($qr)) {
      $country_iso = 'DE';
      $qr = xtc_db_query("SELECT `countries_iso_code_2` FROM `".TABLE_COUNTRIES."` WHERE `countries_id`='".STORE_COUNTRY."' LIMIT 0,1");
      if (xtc_db_num_rows($qr)) {
        $tmp = xtc_db_fetch_array($query);
        if (!empty($tmp)) {
          $country_iso = $tmp['countries_iso_code_2'];
        }
      }
      $sql_data = array(
        'id'          => '1',
        'name'        => 'Google Datenfeed',
        'file_name'   => 'google_default.xml',
        'description' => 'Standard Google Feed',
        'type'        => 'google_xml',
        'cron'        => '1',
        'language'    => $_SESSION['languages_id'],
        'country'     => $country_iso,
        'zone'        => STORE_ZONE,
        'currency'    => DEFAULT_CURRENCY,
        'date_added'  => 'NOW()',
        'last_modified'  => 'NOW()'
      );
      xtc_db_perform('agi_export_feeds', $sql_data);
    }
    
    // prepare configuration
    $pre_config = $this->_get_pre_configuration();
    $conf = array();
    $query_result = xtc_db_query("SELECT `config_key` FROM `agi_export_config`");
    while ($row = xtc_db_fetch_array($query_result)) {
      $conf[] = $row['config_key'];
    }
    foreach ($pre_config as $key => $value) {
      if (!in_array($key, $conf)) {
        xtc_db_perform('agi_export_config', array_merge(array('config_key'=>$key, 'config_value'=>$value['preset'], 'configured'=>0, 'config_group'=>'base'), $value));
      }
    }
    
    // expand tables
    $expand = $this->_get_table_expand_fields();
    foreach ($expand as $table => $fields) {
      $query_result = xtc_db_query("SHOW COLUMNS FROM `" . $table . "`");
      $db_table_rows = array();
      while ($row = xtc_db_fetch_array($query_result)) {
        $db_table_rows[] = $row['Field'];
      }
      $builder = array();
      foreach ($fields as $field => $build) {
        if (!in_array($field, $db_table_rows)) {
          $builder[] = "ADD `$field` $build";
        }
      }
      if (!empty($builder)) {
        xtc_db_query("ALTER TABLE `$table` ".implode(',', $builder));
      }
    }

    // set admin_access
    $query_result = xtc_db_query("SHOW COLUMNS FROM `" . TABLE_ADMIN_ACCESS . "`");
    $db_table_rows = array();
    while ($row = xtc_db_fetch_array($query_result)) {
      $db_table_rows[] = $row['Field'];
    }
    
    if (!in_array('agi_export', $db_table_rows)) {
      xtc_db_query("ALTER TABLE `" . TABLE_ADMIN_ACCESS . "` ADD `agi_export` INT(1) NOT NULL DEFAULT 0");
      xtc_db_query("UPDATE `" . TABLE_ADMIN_ACCESS . "` SET `agi_export` = 1 WHERE `customers_id` = 1");
      if ($_SESSION['customer_id'] != 1) {
        xtc_db_query("UPDATE `" . TABLE_ADMIN_ACCESS . "` SET `agi_export` = 1 WHERE `customers_id` = ".$_SESSION['customer_id']);
      }
      xtc_db_query("UPDATE `" . TABLE_ADMIN_ACCESS . "` SET `agi_export` = 3 WHERE `customers_id`='groups'");
    }
    $this->_internal_updates();
    if (!defined('MODULE_CATEGORIES_AGI_EXPORT_STATUS')) {
      $installed_array = explode(';', MODULE_CATEGORIES_INSTALLED);
      $installed_array[] = 'agi_export.php';
      $installed_array = array_unique($installed_array);
      xtc_db_perform(TABLE_CONFIGURATION, array('configuration_value'=>implode(';', $installed_array)), 'update', "`configuration_key`='MODULE_CATEGORIES_INSTALLED'");
      xtc_redirect(xtc_href_link(FILENAME_MODULES, 'set=categories&module=agi_export&action=install'));
    }
  }

  function remove()
  {
    if (defined($this->name."_UNINSTALL_DATA") && constant($this->name."_UNINSTALL_DATA") == 'true') {
      // reduce tables
      $reduce = $this->_get_table_expand_fields();
      foreach ($reduce as $table => $fields) {
        $query_result = xtc_db_query("SHOW COLUMNS FROM `" . $table . "`");
        $db_table_rows = array();
        while ($row = xtc_db_fetch_array($query_result)) {
          $db_table_rows[] = $row['Field'];
        }
        $builder = array();
        foreach ($fields as $field => $build) {
          if (in_array($field, $db_table_rows)) {
            $builder[] = "DROP `$field`";
          }
        }
        if (!empty($builder)) {
          xtc_db_query("ALTER TABLE `$table` ".implode(',', $builder));
        }
      }
      $this->_internal_remove();
			xtc_db_query("DROP TABLE agi_export_config");
      xtc_db_query("DROP TABLE agi_export_catonoff");
      xtc_db_query("DROP TABLE agi_export_feeds");
      xtc_db_query("DROP TABLE agi_export_cmp_addlink");
      
		} else {
      xtc_db_query("UPDATE `agi_export_config` SET `config_value`='1.0' WHERE `config_key`='version'");
    }
    $keys = $this->keys();
    xtc_db_query("DELETE FROM " . TABLE_CONFIGURATION . " WHERE configuration_key LIKE '".$this->name."%'");
    
    $query_result = xtc_db_query("SHOW COLUMNS FROM `" . TABLE_ADMIN_ACCESS . "`");
    $db_table_rows = array();
    while ($row = xtc_db_fetch_array($query_result)) {
      $db_table_rows[] = $row['Field'];
    }
    if (in_array('agi_export', $db_table_rows)) {
      xtc_db_query("ALTER TABLE `".TABLE_ADMIN_ACCESS."` DROP `agi_export`;");
    }
    if (defined('MODULE_CATEGORIES_AGI_EXPORT_STATUS')) {
      $o_installed_array = explode(';', MODULE_CATEGORIES_INSTALLED);
      $installed_array = array();
      foreach ($o_installed_array as $value) {
        if ($value != 'agi_export.php') {
          $installed_array[] = $value;
        }
      }
      xtc_db_perform(TABLE_CONFIGURATION, array('configuration_value'=>implode(';', $installed_array)), 'update', "`configuration_key`='MODULE_CATEGORIES_INSTALLED'");
      xtc_redirect(xtc_href_link(FILENAME_MODULES, 'set=categories&module=agi_export&action=removeconfirm'));
    }
  }
  
  function keys() 
  {
    defined($this->name.'_STATUS_TITLE') OR define($this->name.'_STATUS_TITLE', TEXT_DEFAULT_STATUS_TITLE);
    defined($this->name.'_STATUS_DESC') OR define($this->name.'_STATUS_DESC', TEXT_DEFAULT_STATUS_DESC);
    $key = array(
      $this->name.'_STATUS',
      $this->name.'_UNINSTALL_DATA'
    );

    return $key;
  }
  
  function _get_pre_configuration()
  {
    $conf = array();
    
    $conf['version'] = array(
      'config_group'  => 'base',
      'preset'        => '1.0',
      'configured'    => 1      
    );

    $conf['attributes_limit_amount'] = array('preset' => 500);
    $conf['vpe_to_title']       = array('preset' => 'false', 'config_group'  => 'google');
    $conf['vpe_to_desc']        = array('preset' => 'false', 'config_group'  => 'google');
    $conf['use_description']    = array('preset' => 'long', 'config_group'  => 'google');
    $conf['google_default_category'] = array('preset' => '', 'config_group'  => 'google');
    $conf['preselect_identifier_exists']  = array('preset' => 1, 'config_group'  => 'google');
    $conf['availability_base']  = array('preset' => 'IN_STOCK');
    $conf['shipping_table']     = array('preset' => 'DE::25:4.90,50:9.90;AT::25:8.90,50:15.90');
    $conf['shipping_base']      = array('preset' => 'price');
    $conf['shipping_ignore_freeshipping'] = array('preset' => 0);
    $conf['products_image']     = array('preset' => 'popup_images', 'config_group'  => 'google');
    
    $conf['clothes_sizesystem'] = array('preset' => 'EU');
    $conf['gender_words_male']  = array('preset' => 'herr,mann,herren');
    $conf['gender_words_female'] = array('preset' => 'frau,dame,damen,frauen');
    $conf['gender_words_unisex'] = array('preset' => 'unisex');
    $conf['group_words_kids']    = array('preset' => 'kind,kinder,kids');
    $conf['group_words_adult']   = array('preset' => 'erwachsen,normal');
    $conf['group_words_newborn'] = array('preset' => 'neugeboren,neugeborene,bis 3 monate');
    $conf['group_words_infant']  = array('preset' => decode_utf8('säugling,säuglinge,baby,3 bis 12 monate'));
    $conf['group_words_toddler'] = array('preset' => 'kleinkind,kleinkinder,1 bis 5 jahre');
    $conf['map_vpe_values']      = array('preset' => '');
    $conf['map_shipping_to_status']= array('preset' => '');
    $conf['ignore_vpe_values']   = array('preset' => decode_utf8('de:Stück;en:piece'));
    $conf['add_attributes_vpe']  = array('preset' => 1);
    $conf['is_utf8_shop']        = array('preset' => 1);
    
    $conf['preselect_clothing_product']   = array('preset' => 0);
    $conf['preselect_condition']          = array('preset' => 'new');
    $conf['preselect_gender']             = array('preset' => 'unisex');
    $conf['preselect_agegroup']           = array('preset' => 'adult');
    $conf['preselect_sizetype']           = array('preset' => 'regular');
    $conf['feed_password']                = array('preset' => 'export_'.date('Ymd'));
    
    return $conf;
  }
  
  function _get_table_expand_fields($table = '')
  {
    $fields = array();
    $fields[TABLE_PRODUCTS] = array(
      'agi_export_condition'    => "VARCHAR(32) NOT NULL DEFAULT 'new'",
      'agi_is_clothing_product' => "TINYINT(1) NOT NULL DEFAULT 0",
      'agi_identifier_exists'   => "TINYINT(1) NOT NULL DEFAULT 1",
      'agi_product_is_a_set'    => "TINYINT(1) NOT NULL DEFAULT 0",
      'agi_bundle_amount'       => "TINYINT(2) NOT NULL DEFAULT 0",
      'agi_expirydate'          => "DATE NOT NULL DEFAULT '0000-00-00'",
      'agi_export_brand'        => "VARCHAR(256) NOT NULL DEFAULT ''",
      'agi_export_length'       => "VARCHAR(32) NOT NULL DEFAULT ''",
      'agi_export_width'        => "VARCHAR(32) NOT NULL DEFAULT ''",
      'agi_export_height'       => "VARCHAR(32) NOT NULL DEFAULT ''",
      'agi_highlight_text'      => "VARCHAR(256) NOT NULL DEFAULT ''",
      'agi_custom_label_1'      => "VARCHAR(256) NOT NULL DEFAULT ''",
      'agi_custom_label_2'      => "VARCHAR(256) NOT NULL DEFAULT ''",
      'agi_custom_label_3'      => "VARCHAR(256) NOT NULL DEFAULT ''",
      'agi_custom_label_4'      => "VARCHAR(256) NOT NULL DEFAULT ''",
      'agi_custom_label_5'      => "VARCHAR(256) NOT NULL DEFAULT ''",
      'agi_size_system'         => "VARCHAR(32) NOT NULL DEFAULT ''",
      'agi_size_type'           => "VARCHAR(32) NOT NULL DEFAULT ''",
      'agi_energy_label'        => "VARCHAR(12) NOT NULL DEFAULT ''",
      'agi_energy_label_sfrom'  => "VARCHAR(12) NOT NULL DEFAULT ''",
      'agi_energy_label_sto'    => "VARCHAR(12) NOT NULL DEFAULT ''",
      'agi_export_gender'       => "VARCHAR(32) NOT NULL DEFAULT ''",
      'agi_export_agegroup'     => "VARCHAR(32) NOT NULL DEFAULT ''",
      'agi_export_image_json'   => "TEXT NULL DEFAULT NULL",
      'agi_google_excluded_destination' => "VARCHAR(256) NOT NULL DEFAULT ''",
      'agi_google_included_destination' => "VARCHAR(256) NOT NULL DEFAULT ''",
      'agi_ekp'                 => "DECIMAL(10,4) NOT NULL DEFAULT '0.00'"
    );
    $qr = xtc_db_query("SELECT `id` FROM `agi_export_feeds` ORDER BY `id`");
    while ($row = xtc_db_fetch_array($qr)) {
      $fields[TABLE_PRODUCTS]['agi_export_feed_'.$row['id']] = "TINYINT(1) NOT NULL DEFAULT 1";
      $fields[TABLE_PRODUCTS]['agi_export_feed_'.$row['id'].'_inputs'] = "TEXT NULL DEFAULT NULL";
    }
    $fields[TABLE_PRODUCTS_DESCRIPTION] = array(
      'agi_google_category'     => "VARCHAR(256) NOT NULL DEFAULT ''",
      'agi_attribute_color'     => "VARCHAR(512) NOT NULL DEFAULT ''",
      'agi_attribute_size'      => "VARCHAR(512) NOT NULL DEFAULT ''",
      'agi_attribute_pattern'   => "VARCHAR(512) NOT NULL DEFAULT ''",
      'agi_attribute_material'  => "VARCHAR(512) NOT NULL DEFAULT ''",
      'agi_alternate_title'     => "VARCHAR(512) NOT NULL DEFAULT ''",
    );
    $fields[TABLE_CATEGORIES_DESCRIPTION] = array(
      'agi_google_category' => "VARCHAR(256) NOT NULL DEFAULT ''"
    );
    $fields[TABLE_PRODUCTS_OPTIONS] = array(
      'agi_export_google_attribut' => "VARCHAR(32) NOT NULL DEFAULT ''"
    );
    if (!empty($table)) {
      return array_key_exists($table, $fields) ? $fields[$table] : array();
    } else {
      return $fields;
    }
  }
  
  function _internal_updates()
  {
    // check updates
    $updates_done = false;
    $query_result = xtc_db_query("SELECT `config_value` FROM `agi_export_config` WHERE `config_key`='version'");
    $tmp = xtc_db_fetch_array($query_result);
    $config_version = $tmp['config_value'];
    $files = scandir(DIR_FS_EXTERNAL.'agi/agi_export/system_updates/');
    foreach ($files as $filename) {
      if (preg_match('/^\d(\.\d{1,2})*\.php$/', $filename)) {
        $filepart = pathinfo($filename,  PATHINFO_FILENAME);
        if (version_compare($filepart, $config_version, '>')) {
          require DIR_FS_EXTERNAL.'agi/agi_export/system_updates/'.$filename;
          $updates_done = true;
        }
      }
    }
    return $updates_done;
  }
  
  function _internal_remove()
  {
    // check removes
    $updates_done = false;
    $query_result = xtc_db_query("SELECT `config_value` FROM `agi_export_config` WHERE `config_key`='version'");
    $tmp = xtc_db_fetch_array($query_result);
    $config_version = $tmp['config_value'];
    $files = scandir(DIR_FS_EXTERNAL.'agi/agi_export/system_removes/', SCANDIR_SORT_DESCENDING);
    foreach ($files as $filename) {
      if (preg_match('/^\d(\.\d{1,2})*\.php$/', $filename)) {
        $filepart = pathinfo($filename,  PATHINFO_FILENAME);
        if (version_compare($filepart, $config_version, '<=')) {
          require DIR_FS_EXTERNAL.'agi/agi_export/system_removes/'.$filename;
          $updates_done = true;
        }
      }
    }
    return $updates_done;
  }
}
