<?php
/* includes/external/agi/agi_export/admin/functions.php
.---------------------------------------------------------------------------.
|    Software: agi_export for modified eCommerce                            |
|      Author: Andreas Guder                                                |
|     Contact: info@andreas-guder.de                                        |
| Copyright (c) 2022, Andreas Guder [info@andreas-guder.de]                 |
|               All Rights Reserved.                                        |
| ------------------------------------------------------------------------- |
|     License: you are not allowed to distribute                            |
|              or sublicense copies of the software without                 |
|              a grant of a licence of the coyright-owner                   |
'---------------------------------------------------------------------------ü
*/
$_agi_export_config = array();

function agi_export_get_config($key, $type='value') {
  global $_agi_export_config;
  if (empty($key) || !in_array($type, array('value','preset'))) {
    return '';
  }
  if ($key == '*') {
    $qr = xtc_db_query("SELECT `config_key`, `preset`, IF (`configured`=1, `config_value`, `preset`) AS conf_value FROM agi_export_config");
    while ($row = xtc_db_fetch_array($qr)) {
      $_agi_export_config[$row['config_key']] = array('value' => $row['conf_value'], 'preset'=> $row['preset']);
    }
    return true;
  }
  
  $response = array();
  $keys = explode(',', $key);
  $to_load = array();
  foreach ($keys as $value) {
    if (array_key_exists($value, $_agi_export_config)) {
      $response[$value] = $_agi_export_config[$value][$type];
    } else {
      $to_load[] = $value;
      $response[$value] = '';
      $_agi_export_config[$value] = array('value' => '', 'preset' => '');
    }
  }
  if (!empty($to_load)) {
    $qr = xtc_db_query("SELECT `config_key`, `preset`, IF (`configured`=1, `config_value`, `preset`) AS conf_value FROM agi_export_config WHERE `config_key` IN ('".implode("',", $to_load)."')");
    while ($row = xtc_db_fetch_array($qr)) {
      $_agi_export_config[$row['config_key']] = array('value' => $row['conf_value'], 'preset'=> $row['preset']);
      $response[$row['config_key']] = $_agi_export_config[$row['config_key']][$type];
    }
  }
  return count($response) === 1 ? $response[$key] : $response;
}

function agi_export_config_parse_map_shipping_to_status($data) {
  if (!is_array($data) || empty($data)) {
    return '';
  }
  $response = array();
  foreach ($data as $key => $value) {
    $response[(int)$key] = $value;
  }
  return json_encode($response, JSON_UNESCAPED_UNICODE);
}

function agi_export_get_categories_products($cId, $cparent_array, $export_status, $feed) {
  xtc_db_query("DELETE FROM `agi_export_catonoff` WHERE `category`=$cId AND `feed`=".$feed);
  if ($export_status) {
    $sql_data = array(
      'feed'      => $feed,
      'category'  => $cId,
      'preselect' => 'a'
    );
    xtc_db_perform('agi_export_catonoff',$sql_data);
  }
  $qr = xtc_db_query("SELECT IFNULL(GROUP_CONCAT(`products_id`),'') AS pids FROM `".TABLE_PRODUCTS_TO_CATEGORIES."` WHERE `categories_id`=".$cId);
  $result_list = array();
  if (xtc_db_num_rows($qr)) {
    $row = xtc_db_fetch_array($qr);
    if (!empty($row['pids'])) {
      agi_export_set_google_export_allowed($row['pids'], $export_status, $feed);
    }
  }
  if(array_key_exists($cId,$cparent_array)) {
    foreach($cparent_array[$cId] as $child) {
      agi_export_get_categories_products($child, $cparent_array, $export_status, $feed);
    }
  }
}

function agi_export_set_google_export_allowed($p_list, $set_status, $feed) {
  xtc_db_query("UPDATE `".TABLE_PRODUCTS."` SET `agi_export_feed_$feed`='".$set_status."' WHERE `products_id` IN (".$p_list.")");
}

function agi_url_cleaned_name($name) {
  $name = decode_utf8($name);
  $search_array=array('ä','Ä','ö','Ö','ü','Ü','ß','&auml;','&Auml;','&ouml;','&Ouml;','&uuml;','&Uuml;','&szlig;');
  $replace_array=array('ae','Ae','oe','Oe','ue','Ue','ss','ae','Ae','oe','Oe','ue','Ue','ss');
  $name=str_replace($search_array,$replace_array,$name);   	

  $replace_param='/[^a-zA-Z0-9\-\_\.]/';
  $name=preg_replace($replace_param,'_',$name);
  
  return $name;
}

function agi_export_cmp_csv_fields($a, $b) {
  if ($a['sortorder'] == $b['sortorder']) {
    return 0;
  }
  return ($a['sortorder'] < $b['sortorder']) ? -1 : 1;
}
