<?php
/* includes/external/agi/agi_export/admin/hooked/application_top_end.php
.---------------------------------------------------------------------------.
|    Software: agi_export for modified eCommerce                            |
|      Author: Andreas Guder                                                |
|     Contact: info@andreas-guder.de                                        |
| Copyright (c) 2022, Andreas Guder [info@andreas-guder.de]                 |
|               All Rights Reserved.                                        |
| ------------------------------------------------------------------------- |
|     License: you are not allowed to distribute                            |
|              or sublicense copies of the software without                 |
|              a grant of a licence of the coyright-owner                   |
'---------------------------------------------------------------------------ü
*/
if (!defined('MODULE_SYSTEM_AGI_EXPORT_STATUS') || (defined('MODULE_SYSTEM_AGI_EXPORT_STATUS') && MODULE_SYSTEM_AGI_EXPORT_STATUS != 'true')) {
  return;
}

if (basename($PHP_SELF) == FILENAME_CATEGORIES) {
  require_once DIR_FS_EXTERNAL.'agi/agi_export/admin/functions.php';
  if (isset($_POST['multi_google_switch_export_on'])) {
    $export_feeds = (int)$_POST['agi_export_switch_feed_onoff'];
    $export_status = (int)$_POST['agi_export_switch_feed_onoff_status'];
    $products_list = array();
    if (array_key_exists('multi_categories', $_POST) && is_array($_POST['multi_categories'])) {
      // load tmp_categories to create parents
      $qr = xtDBquery('SELECT `categories_id`,`parent_id` FROM `'.TABLE_CATEGORIES.'`');
      $tmp_cat = array();
      while ($row = xtc_db_fetch_array($qr, true)) {
        $tmp_cat[$row['categories_id']] = $row['parent_id'];
      }
      $cparent_array = array();
      foreach($tmp_cat as $ckey => $cparent) {
        if (!array_key_exists($cparent,$cparent_array)) {
          $cparent_array[$cparent] = array();
        }
        $cparent_array[$cparent][$ckey] = $ckey;
      }
      foreach ($_POST['multi_categories'] AS $category_id) {
        agi_export_get_categories_products((int)$category_id, $cparent_array, $export_status, $export_feeds);
      }
    }
    if (array_key_exists('multi_products', $_POST) && is_array($_POST['multi_products'])) {
      foreach ($_POST['multi_products'] AS $product_id) {
        $products_list[] = (int)$product_id;
      }
    }
    if (!empty($products_list)) {
      $products_list = array_unique($products_list);
      agi_export_set_google_export_allowed(implode(',', $products_list), $export_status, $export_feeds);
    }
    xtc_redirect(xtc_href_link(FILENAME_CATEGORIES, xtc_get_all_get_params(array('cPath', 'action', 'pID', 'cID')).'cPath='.$_GET['cPath']));
  }
  if (isset($_GET['action']) && in_array($_GET['action'], array('update_product','insert_product'))) {
    if (isset($_POST['agi_highlight_text']) && is_array($_POST['agi_highlight_text'])) {
      $agi_highlight_text = array();
      foreach ($_POST['agi_highlight_text'] as $lang_id => $lang_data) {
        $tmp = array();
        foreach ($lang_data as $data_input) {
          if (!empty($data_input)) {
            $tmp[] = encode_utf8($data_input, '', true);
          }
        }
        $agi_highlight_text[$lang_id] = !empty($tmp) ? json_encode($tmp, JSON_UNESCAPED_UNICODE) : '';
      }
      $_POST['agi_highlight_text'] = $agi_highlight_text;
    }
  }
}

if (basename($PHP_SELF) == FILENAME_PRODUCTS_ATTRIBUTES) {
  if (isset($_GET['action']) && $_GET['action'] == 'save_options' && isset($_GET['oID']) && !empty($_GET['oID'])) {
    if (isset($_POST['choose_google_attribute'])) {
      $set = '';
      if (in_array($_POST['choose_google_attribute'], array('color','size','pattern','material','gender','agegroup'))) {
        $set = $_POST['choose_google_attribute'];
      }
      xtc_db_perform(TABLE_PRODUCTS_OPTIONS, array('agi_export_google_attribut' => $set), 'update', "`products_options_id`='".(int)$_GET['oID']."'");
    }
  }
}
