<?php
/* includes/external/agi/agi_export/admin/hooked/modules_new_category.php
.---------------------------------------------------------------------------.
|    Software: agi_export for modified eCommerce                            |
|      Author: Andreas Guder                                                |
|     Contact: info@andreas-guder.de                                        |
| Copyright (c) 2022, Andreas Guder [info@andreas-guder.de]                 |
|               All Rights Reserved.                                        |
| ------------------------------------------------------------------------- |
|     License: you are not allowed to distribute                            |
|              or sublicense copies of the software without                 |
|              a grant of a licence of the coyright-owner                   |
'---------------------------------------------------------------------------ü
*/
if (!defined('MODULE_SYSTEM_AGI_EXPORT_STATUS') || (defined('MODULE_SYSTEM_AGI_EXPORT_STATUS') && MODULE_SYSTEM_AGI_EXPORT_STATUS != 'true')) {
  return;
}

require_once DIR_FS_CATALOG . 'lang/' . $_SESSION['language'] . '/modules/system/agi_export.php';

$agi_google_cats = array();
if (!empty($cInfo->categories_id)) {
  $qr = xtc_db_query("SELECT `language_id`, `agi_google_category` FROM `".TABLE_CATEGORIES_DESCRIPTION."` WHERE `categories_id`=".$cInfo->categories_id);
  while ($row = xtc_db_fetch_array($qr)) {
    $agi_google_cats[$row['language_id']] = $row['agi_google_category'];
  }
}

$agi_export_google_taxonomie_list = array();
for ($i = 0, $n = sizeof($languages); $i < $n; $i++) {
  $agi_export_google_taxonomie_list[$languages[$i]['code']] = array(array('id'=>0, 'text'=>''));
  if (file_exists(DIR_FS_DOCUMENT_ROOT.'export/google_taxonomie.'.$languages[$i]['code'].'.txt')) {
    $tmp_data = file(DIR_FS_DOCUMENT_ROOT.'export/google_taxonomie.'.$languages[$i]['code'].'.txt', FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
    foreach ($tmp_data as $key => $value) {
      $prefix = '';
      if (preg_match('/^(\d+ - )(.+?)$/', $value, $matches)) {
        $prefix = $matches[1];
        $value = $matches[2];
      }
      if (mb_strlen($value) > 100) {
        $last = mb_substr($value, -110);
        $parsed_value = $prefix.'[..] '.mb_substr($last, mb_strpos($last, '>') !== false ? mb_strpos($last, '>')+2 : 0);
      }
      else {
        $parsed_value = $prefix.$value;
      }
      $agi_export_google_taxonomie_list[$languages[$i]['code']][] = array('id'=>$prefix.$value, 'text'=>encode_htmlentities($parsed_value));
    }
  }
}

  for ($i = 0; $i < sizeof($languages); $i++) { 
    $lng_image = xtc_image(DIR_WS_LANGUAGES . $languages[$i]['directory'] .'/admin/images/'. $languages[$i]['image'], $languages[$i]['name']);
?>
  <div id="agi_export_google_categories_lang_<?php echo $i; ?>">
    <div class="main" style="padding: 3px; line-height:20px; margin-bottom:20px;">
      <?php echo $lng_image.' '.MODULE_AGI_EXPORT_GOOGLE_CATEGORY_TEXT; ?><br />
      <?php echo xtc_draw_input_field('agi_google_category['.$languages[$i]['id'].']', !empty($agi_google_cats[$languages[$i]['id']]) ? $agi_google_cats[$languages[$i]['id']] : '', 'size="50" style="width: 96%" id="agi_google_category_'.$languages[$i]['id'].'"'); ?><br />
      <br />
      <?php echo xtc_draw_pull_down_menu('agi_google_taxonomie_select_'.$languages[$i]['id'], $agi_export_google_taxonomie_list[$languages[$i]['code']], array_key_exists($languages[$i]['id'], $agi_google_cats) ? $agi_google_cats[$languages[$i]['id']] : '', 'style="width:75%;" id="agi_google_taxonomie_select_'.$languages[$i]['id'].'" class="noStyling"'); ?>
      <?php echo '<a href="#" class="button" title="'.MODULE_AGI_EXPORT_GOOGLE_TAXONOMIE_FILLIN_BUTTON.'" onclick="agi_export_fillinGoogleCategory('.$languages[$i]['id'].');return false;">'.MODULE_AGI_EXPORT_GOOGLE_TAXONOMIE_FILLIN_BUTTON.'</a>'; ?>
    </div>
  </div>
<?php } ?>

<script>
$(function() { 
  <?php for ($i = 0; $i < sizeof($languages); $i++) { ?>
    $('#agi_export_google_categories_lang_<?php echo $i; ?>').detach().appendTo($('#tab_lang_<?php echo $i; ?>'));
  <?php } ?>
});
function agi_export_fillinGoogleCategory(language_id) {
  if (document.getElementById('agi_google_category_'+language_id) && document.getElementById('agi_google_taxonomie_select_'+language_id)) {
    var source = document.getElementById('agi_google_taxonomie_select_'+language_id);
    var target = document.getElementById('agi_google_category_'+language_id);
    var category_string = source[source.selectedIndex].value;
    target.value = category_string == '0' ? '' : category_string;
  }
}
</script>