<?php
/* includes/external/agi/agi_export/admin/hooked/modules_new_product.php
.---------------------------------------------------------------------------.
|    Software: agi_export for modified eCommerce                            |
|      Author: Andreas Guder                                                |
|     Contact: info@andreas-guder.de                                        |
| Copyright (c) 2022, Andreas Guder [info@andreas-guder.de]                 |
|               All Rights Reserved.                                        |
| ------------------------------------------------------------------------- |
|     License: you are not allowed to distribute                            |
|              or sublicense copies of the software without                 |
|              a grant of a licence of the coyright-owner                   |
'---------------------------------------------------------------------------ü
*/
if (!defined('MODULE_SYSTEM_AGI_EXPORT_STATUS') || (defined('MODULE_SYSTEM_AGI_EXPORT_STATUS') && MODULE_SYSTEM_AGI_EXPORT_STATUS != 'true')) {
  return;
}

  require_once DIR_FS_CATALOG . 'lang/' . $_SESSION['language'] . '/modules/system/agi_export.php';
  agi_export_get_config('*');
  
  $options_onoff = array(
    array('id' => 1, 'text' => YES),
    array('id' => 0, 'text' => NO)
  );
  $options_conditions = array(
    array('id' => 'new', 'text' => MODULE_AGI_EXPORT_PRODUCTS_STATUS_NEW), 
    array('id' => 'used', 'text' => MODULE_AGI_EXPORT_PRODUCTS_STATUS_USED),
    array('id' => 'refurbished', 'text' => MODULE_AGI_EXPORT_PRODUCTS_STATUS_REFURBISHED)
  );
  $options_size_system = array(
    array('id' => '', 'text' => '-'),
    array('id' => 'EU', 'text' => 'EU'),
    array('id' => 'DE', 'text' => 'DE'),
    array('id' => 'US', 'text' => 'US'),
    array('id' => 'UK', 'text' => 'UK'),
    array('id' => 'FR', 'text' => 'FR'),
    array('id' => 'JP', 'text' => 'JP'),
    array('id' => 'CN', 'text' => 'CN'),
    array('id' => 'IT', 'text' => 'IT'),
    array('id' => 'BR', 'text' => 'BR'),
    array('id' => 'MEX', 'text' => 'MEX'),
    array('id' => 'AU', 'text' => 'AU')
  );
  $options_sizetype = array(
    array('id' => '', 'text' => '-'),
    array('id' => 'regular', 'text' => MODULE_AGI_EXPORT_PRODUCTS_SIZETYP_REGULAR),
    array('id' => 'petite', 'text' => MODULE_AGI_EXPORT_PRODUCTS_SIZETYP_PETITE),
    array('id' => 'plus', 'text' => MODULE_AGI_EXPORT_PRODUCTS_SIZETYP_PLUS),
    array('id' => 'maternity', 'text' => MODULE_AGI_EXPORT_PRODUCTS_SIZETYP_MATERNITY)
  );
  $options_gender = array(
    array('id' => '', 'text' => '-'), 
    array('id' => 'unisex', 'text' => MODULE_AGI_EXPORT_PRODUCTS_GENDER_UNISEX), 
    array('id' => 'female', 'text' => MODULE_AGI_EXPORT_PRODUCTS_GENDER_FEMALE), 
    array('id' => 'male', 'text' => MODULE_AGI_EXPORT_PRODUCTS_GENDER_MALE)
  );
  $options_agegroup = array(
    array('id' => '', 'text' => '-'),
    array('id' => 'adult', 'text' => MODULE_AGI_EXPORT_PRODUCTS_AGEGROUP_ADULT),
    array('id' => 'kids', 'text' => MODULE_AGI_EXPORT_PRODUCTS_AGEGROUP_KIDS),
    array('id' => 'newborn', 'text' => MODULE_AGI_EXPORT_PRODUCTS_AGEGROUP_NEWBORN),
    array('id' => 'infant', 'text' => MODULE_AGI_EXPORT_PRODUCTS_AGEGROUP_INFANT),
    array('id' => 'toddler', 'text' => MODULE_AGI_EXPORT_PRODUCTS_AGEGROUP_TODDLER)
  );
  $options_energy_label = array(
    array('id' => '', 'text' => '-'),
    array('id' => 'A+++', 'text' => 'A+++'),
    array('id' => 'A++', 'text' => 'A++'),
    array('id' => 'A+', 'text' => 'A+'),
    array('id' => 'A', 'text' => 'A'),
    array('id' => 'B', 'text' => 'B'),
    array('id' => 'C', 'text' => 'C'),
    array('id' => 'D', 'text' => 'D'),
    array('id' => 'E', 'text' => 'E'),
    array('id' => 'F', 'text' => 'F'),
    array('id' => 'G', 'text' => 'G')
  );
  $options_google_destination = array(
    array('id' => 'Shopping_ads', 'text' => 'Shopping ads'),
    array('id' => 'Buy_on_Google_listings', 'text' => 'Buy on Google listings'),
    array('id' => 'Display_ads', 'text' => 'Display ads'),
    array('id' => 'Local_inventory_ads', 'text' => 'Local inventory ads'),
    array('id' => 'Free_listings', 'text' => 'Free listings'),
    array('id' => 'Free_local_listings', 'text' => 'Free local listings')
  );
  
  $agi_export_google_taxonomie_list = array();
  for ($i = 0, $n = sizeof($languages); $i < $n; $i++) {
    $agi_export_google_taxonomie_list[$languages[$i]['code']] = array(array('id'=>0, 'text'=>''));
    if (file_exists(DIR_FS_DOCUMENT_ROOT.'export/google_taxonomie.'.$languages[$i]['code'].'.txt')) {
      $tmp_data = file(DIR_FS_DOCUMENT_ROOT.'export/google_taxonomie.'.$languages[$i]['code'].'.txt', FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
      foreach ($tmp_data as $key => $value) {
        $prefix = '';
        if (preg_match('/^(\d+ - )(.+?)$/', $value, $matches)) {
          $prefix = $matches[1];
          $value = $matches[2];
        }
        if (mb_strlen($value) > 100) {
          $last = mb_substr($value, -110);
          $parsed_value = $prefix.'[..] '.mb_substr($last, mb_strpos($last, '>') !== false ? mb_strpos($last, '>')+2 : 0);
        }
        else {
          $parsed_value = $prefix.$value;
        }
        $agi_export_google_taxonomie_list[$languages[$i]['code']][] = array('id'=>$prefix.$value, 'text'=>encode_htmlentities($parsed_value));
      }
    }
  }
  
  $agi_export_lang_data = array();
  if (!empty($pInfo->products_id)) {
    $qr = xtc_db_query("SELECT `language_id`, `agi_google_category`, `agi_attribute_color`, `agi_attribute_size`, `agi_attribute_pattern`, `agi_attribute_material`, `agi_alternate_title`,`agi_highlight_text` FROM `".TABLE_PRODUCTS_DESCRIPTION."` WHERE `products_id`=".$pInfo->products_id);
    while ($row = xtc_db_fetch_array($qr)) {
      $agi_export_lang_data[$row['language_id']] = $row;
      if (!empty($row['agi_highlight_text'])) {
        $substr = substr($row['agi_highlight_text'], 0, 1);
        if (in_array($substr, array('{','['))) {
          $agi_export_lang_data[$row['language_id']]['agi_highlight_text'] = json_decode($row['agi_highlight_text'], true);
        } else {
          $agi_export_lang_data[$row['language_id']]['agi_highlight_text'] = array($row['agi_highlight_text']);
        }
      } else {
        $agi_export_lang_data[$row['language_id']]['agi_highlight_text'] = array();
      }
    }
  }
  
  // load feeds
  $profiles = array();
  $qr = xtc_db_query("SELECT `id`, `export_allowed`, `name`, `description`, `input_fields` FROM `agi_export_feeds`");
  while ($row = xtc_db_fetch_array($qr)) {
    $profiles[$row['id']] = $row;
  }
?>
<div style="padding:5px;background:#e6e6e6;display:none" class="clear" id="module_agi_export_wrapper">
  <div class="main div_header"><?php echo MODULE_SYSTEM_AGI_EXPORT_TITLE; ?></div>
  <div class="clear div_box mrg5">
    <div class="main div_header"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TITLE_FEED_ACTIVATION; ?></div>
    <table>
      <tr class="dataTableHeadingRow">
        <td class="dataTableHeadingContent"><?php echo MODULE_AGI_EXPORT_PRODUCTS_HEADING_FEED_NAME; ?></td>
        <td class="dataTableHeadingContent"><?php echo MODULE_AGI_EXPORT_PRODUCTS_HEADING_FEED_ACTIVATION; ?></td>
        <td class="dataTableHeadingContent"><?php echo MODULE_AGI_EXPORT_PRODUCTS_HEADING_FEED_INPUTS; ?></td>
      </tr>
      <?php foreach ($profiles as $row) { ?>
      <tr class="dataTableRow">
        <td class="dataTableContent"><?php echo encode_htmlentities(decode_utf8($row['name'])).(!empty($row['description']) ? draw_tooltip(encode_htmlentities(decode_utf8($row['description']))) : ''); ?></td>
        <td class="dataTableContent"><?php echo draw_on_off_selection('agi_export_feed_'.$row['id'], $options_onoff, !empty($pInfo->products_id) ? $pInfo->{'agi_export_feed_'.$row['id']} : $row['export_allowed']); ?></td>
        <td class="dataTableContent">
        <?php if (!empty($row['input_fields'])) { ?>
          <table>
          <?php
            $input_fields = json_decode($row['input_fields'], true);
            $input_fields_values = array();
            if (property_exists($pInfo, 'agi_export_feed_'.$row['id'].'_inputs') && !empty($pInfo->{'agi_export_feed_'.$row['id'].'_inputs'})) {
              $input_fields_values = json_decode($pInfo->{'agi_export_feed_'.$row['id'].'_inputs'}, true);
            }
            foreach ($input_fields as $input_data) {
          ?>
            <tr>
              <td class="categories_view_data"><?php echo encode_htmlentities(decode_utf8($input_data['name'])).' '.(!empty($input_data['desc']) ? draw_tooltip(encode_htmlentities(decode_utf8($input_data['desc']))) : ''); ?></td>
              <td class="categories_view_data">
                <?php echo xtc_draw_input_field('agi_export_feed_'.$row['id'].'_inputs['.$input_data['key'].']', array_key_exists($input_data['key'], $input_fields_values) ? decode_utf8($input_fields_values[$input_data['key']]) : ''); ?>
                <?php if (array_key_exists('preset_active', $input_data) && $input_data['preset_active'] && $input_data['preset'] != '') { ?>
                  <br /><small><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_FEED_INPUTS_DEFAULT; ?>: <?php echo encode_htmlentities(decode_utf8($input_data['preset'])); ?></small>
                <?php } ?>
              </td>
            </tr>
            <?php } ?>
          </table>
        <?php } ?>
        </td>
      </tr>
      <?php } ?>
    </table>
  </div>
  <div class="clear div_box mrg5">
    <div class="main div_header"><?php echo MODULE_AGI_EXPORT_PRODUCTS_SETTINGS_TITLE; ?></div>
    <table class="tableInput border0">
      <tr>
        <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_IDENTIFIER_EXISTS; ?></span></td>
        <td><?php echo draw_on_off_selection('agi_identifier_exists', $options_onoff, isset($pInfo->agi_identifier_exists) ? $pInfo->agi_identifier_exists : (agi_export_get_config('preselect_identifier_exists') == 1 ? true : false)); ?></td>
        <td style="width: 30px"></td>
        <td><span class="main"><?php echo draw_tooltip(MODULE_AGI_EXPORT_PRODUCTS_TTIP_IS_A_SET).' '.MODULE_AGI_EXPORT_PRODUCTS_TEXT_IS_A_SET; ?></span></td>
        <td><?php echo draw_on_off_selection('agi_product_is_a_set', $options_onoff, isset($pInfo->agi_product_is_a_set) ? $pInfo->agi_product_is_a_set : false); ?></td>
      </tr>
      <tr>
        <td><span class="main"><?php echo draw_tooltip(MODULE_AGI_EXPORT_PRODUCTS_TTIP_IS_MULTIPACK).' '.MODULE_AGI_EXPORT_PRODUCTS_TEXT_IS_MULTIPACK; ?></span></td>
        <td><?php echo xtc_draw_input_field('agi_bundle_amount', isset($pInfo->agi_bundle_amount) ? $pInfo->agi_bundle_amount : 0); ?></td>
        <td style="width: 30px"></td>
        <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_EXPIRYDATE; ?></span></td>
        <td><?php echo xtc_draw_input_field('agi_expirydate', isset($pInfo->agi_expirydate) ? $pInfo->agi_expirydate : '0000-00-00', '', false, 'date'); ?></td>
      </tr>
      <tr>
        <td rowspan="2"><span class="main"><?php echo draw_tooltip(MODULE_AGI_EXPORT_PRODUCTS_TTIP_IS_CLOTHES).' '.MODULE_AGI_EXPORT_PRODUCTS_TEXT_IS_CLOTHES; ?></span></td>
        <td rowspan="2"><?php echo draw_on_off_selection('agi_is_clothing_product', $options_onoff, isset($pInfo->agi_is_clothing_product) ? $pInfo->agi_is_clothing_product : (agi_export_get_config('preselect_clothing_product') == 1 ? true : false)); ?></td>
        <td rowspan="2" class=""></td>
        <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_CLOTHING_SIZETYPE; ?></span></td>
        <td><?php echo xtc_draw_pull_down_menu('agi_size_type', $options_sizetype, isset($pInfo->agi_size_type) ? $pInfo->agi_size_type : (agi_export_get_config('preselect_clothing_product') ? agi_export_get_config('preselect_sizetype') : '')); ?></td>
      </tr>
      <tr>
        <td><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_CLOTHING_SIZESYSTEM; ?></td>
        <td><?php echo xtc_draw_pull_down_menu('agi_size_system', $options_size_system, isset($pInfo->agi_size_system) ? $pInfo->agi_size_system : (agi_export_get_config('preselect_clothing_product') ? agi_export_get_config('clothes_sizesystem') : '')); ?></td>
      </tr>
      <tr>
        <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_GENDER; ?></span></td>
        <td><?php echo xtc_draw_pull_down_menu('agi_export_gender', $options_gender, isset($pInfo->agi_export_gender) ? $pInfo->agi_export_gender : agi_export_get_config('preselect_gender')); ?></td>
        <td style="width: 30px"></td>
        <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_AGEGROUP; ?></span></td>
        <td><?php echo xtc_draw_pull_down_menu('agi_export_agegroup', $options_agegroup, isset($pInfo->agi_export_agegroup) ? $pInfo->agi_export_agegroup : agi_export_get_config('preselect_agegroup')); ?></td>
      </tr>
      <tr>
        <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_CONDITION; ?></span></td>
        <td><?php echo xtc_draw_pull_down_menu('agi_export_condition', $options_conditions, isset($pInfo->agi_export_condition) ? $pInfo->agi_export_condition : agi_export_get_config('preselect_condition')); ?></td>
        <td style="width: 30px"></td>
        <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_BRAND; ?></span></td>
        <td><?php echo xtc_draw_input_field('agi_export_brand', isset($pInfo->agi_export_brand) ? $pInfo->agi_export_brand : '', 'maxlength="124"'); ?></td>
      </tr>
      <tr>
        <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_EFFICENCY; ?></span></td>
        <td><?php echo xtc_draw_pull_down_menu('agi_energy_label', $options_energy_label, isset($pInfo->agi_energy_label) ? $pInfo->agi_energy_label : ''); ?></td>
        <td style="width: 30px"></td>
        <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_EFFICENCY_SCALE; ?></span></td>
        <td>
          <?php echo xtc_draw_pull_down_menu('agi_energy_label_sfrom', $options_energy_label, isset($pInfo->agi_energy_label_sfrom) ? $pInfo->agi_energy_label_sfrom : ''); ?>
          <?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_TO; ?>
          <?php echo xtc_draw_pull_down_menu('agi_energy_label_sto', $options_energy_label, isset($pInfo->agi_energy_label_sto) ? $pInfo->agi_energy_label_sto : ''); ?>
        </td>
      </tr>
      <tr>
        <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_LENGTH; ?></span></td>
        <td><?php echo xtc_draw_input_field('agi_export_length', isset($pInfo->agi_export_length) ? $pInfo->agi_export_length : ''); ?></td>
        <td style="width: 30px"></td>
        <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_WIDTH; ?></span></td>
        <td><?php echo xtc_draw_input_field('agi_export_width', isset($pInfo->agi_export_width) ? $pInfo->agi_export_width : ''); ?></td>
      </tr>
      <tr>
        <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_HEIGHT; ?></span></td>
        <td><?php echo xtc_draw_input_field('agi_export_height', isset($pInfo->agi_export_height) ? $pInfo->agi_export_height : ''); ?></td>
        <td style="width: 30px"></td>
        <td></td>
        <td></td>
      </tr>
      <tr>
        <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_COST_OF_GOODS_SOLD; ?></span></td>
        <td><?php echo xtc_draw_input_field('agi_ekp', isset($pInfo->agi_ekp) ? $pInfo->agi_ekp : '0'); ?></td>
        <td style="width: 30px"></td>
        <td><span class="main"><?php echo draw_tooltip(MODULE_AGI_EXPORT_PRODUCTS_TEXT_TTIP_PGROUP_ID).' '.MODULE_AGI_EXPORT_PRODUCTS_TEXT_PGROUP_ID; ?></span></td>
        <td><?php echo xtc_draw_input_field('agi_export_pgroup_id', isset($pInfo->agi_export_pgroup_id) ? $pInfo->agi_export_pgroup_id : '', 'maxlength="50"'); ?></td>
      </tr>
      <tr>
        <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_GOOGLE_DEST_EXCLUDE; ?></span></td>
        <td>
        <?php
          $tmp = isset($pInfo->agi_google_excluded_destination) && !empty($pInfo->agi_google_excluded_destination) ? explode(',', $pInfo->agi_google_excluded_destination) : array();
          foreach ($options_google_destination as $row) {
            echo '<label>'.xtc_draw_checkbox_field('agi_export_google_destination_exclude[]', $row['id'], in_array($row['id'], $tmp)).' '.$row['text'].'</label><br />';
          }
        ?>
        </td>
        <td style="width: 30px"></td>
        <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_GOOGLE_DEST_INCLUDE; ?></span></td>
        <td>
        <?php
          $tmp = isset($pInfo->agi_google_included_destination) && !empty($pInfo->agi_google_included_destination) ? explode(',', $pInfo->agi_google_included_destination) : array();
          foreach ($options_google_destination as $row) {
            echo '<label>'.xtc_draw_checkbox_field('agi_export_google_destination_include[]', $row['id'], in_array($row['id'], $tmp)).' '.$row['text'].'</label><br />';
          }
        ?>
        </td>
      </tr>
      <tr>
        <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_CUSTOMLABEL; ?></span></td>
        <td colspan="4">
          <table class="tableInput border0">
            <tr>
              <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_CUSTOMLABEL1; ?></span></td>
              <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_CUSTOMLABEL2; ?></span></td>
              <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_CUSTOMLABEL3; ?></span></td>
              <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_CUSTOMLABEL4; ?></span></td>
              <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_CUSTOMLABEL5; ?></span></td>
            </tr>
            <tr>
              <td><?php echo xtc_draw_input_field('agi_custom_label_1', isset($pInfo->agi_custom_label_1) ? $pInfo->agi_custom_label_1 : '', 'maxlength="125"'); ?></td>
              <td><?php echo xtc_draw_input_field('agi_custom_label_2', isset($pInfo->agi_custom_label_2) ? $pInfo->agi_custom_label_2 : '', 'maxlength="125"'); ?></td>
              <td><?php echo xtc_draw_input_field('agi_custom_label_3', isset($pInfo->agi_custom_label_3) ? $pInfo->agi_custom_label_3 : '', 'maxlength="125"'); ?></td>
              <td><?php echo xtc_draw_input_field('agi_custom_label_4', isset($pInfo->agi_custom_label_4) ? $pInfo->agi_custom_label_4 : '', 'maxlength="125"'); ?></td>
              <td><?php echo xtc_draw_input_field('agi_custom_label_5', isset($pInfo->agi_custom_label_5) ? $pInfo->agi_custom_label_5 : '', 'maxlength="125"'); ?></td>
            </tr>
          </table>
        </td>
      </tr>
    </table>
    <div style="padding:5px;clear:both;">
      <div class="tablangmenu">
        <ul>
        <?php for ($i = 0, $n = sizeof($languages); $i < $n; $i++) { ?>
          <li id="agi_lang_tabselect_<?php echo $i; ?>" onclick="agi_export_showTab('agi_lang',<?php echo $i; ?>,<?php echo $n; ?>)" style="cursor:pointer; <?php echo $i==0 ? ' color:#000;background-color:#d0d0d0;' : ''?>"><?php echo xtc_image(DIR_WS_LANGUAGES . $languages[$i]['directory'] .'/admin/images/'. $languages[$i]['image'], $languages[$i]['name']) . ' ' . $languages[$i]['name']; ?></li>
        <?php } ?>
        </ul>
      </div>
      <?php for ($i = 0, $n = sizeof($languages); $i < $n; $i++) { ?>
      <?php 
        $lng_image = xtc_image(DIR_WS_LANGUAGES . $languages[$i]['directory'] .'/admin/images/'. $languages[$i]['image'], $languages[$i]['name']); 
        if (empty($tmp)) {
          $tmp = array();
        }
      ?>
      <div id="agi_lang_tab_<?php echo $i; ?>" style="display:<?php echo $i>0 ? 'none;':'block;';?> border:1px solid #aaa;">
        <p class="mrg5"><?php echo $lng_image.' '.$languages[$i]['name']; ?></p>
        <table class="tableInput border0">
          <tr>
            <td><span class="main"><?php echo draw_tooltip(MODULE_AGI_EXPORT_PRODUCTS_TTIP_ATTRIBUT_COLOR).' '.MODULE_AGI_EXPORT_PRODUCTS_TEXT_ATTRIBUT_COLOR; ?></span></td>
            <td><span class="main"><?php echo xtc_draw_input_field('agi_attribute_color['.$languages[$i]['id'].']', !empty($agi_export_lang_data[$languages[$i]['id']]['agi_attribute_color']) ? $agi_export_lang_data[$languages[$i]['id']]['agi_attribute_color'] : '', 'style="width:100%"'); ?></span></td>
            <td style="width: 30px"></td>
            <td><span class="main"><?php echo draw_tooltip(MODULE_AGI_EXPORT_PRODUCTS_TTIP_ATTRIBUT_SIZE).' '.MODULE_AGI_EXPORT_PRODUCTS_TEXT_ATTRIBUT_SIZE; ?></span></td>
            <td><span class="main"><?php echo xtc_draw_input_field('agi_attribute_size['.$languages[$i]['id'].']', !empty($agi_export_lang_data[$languages[$i]['id']]['agi_attribute_size']) ? $agi_export_lang_data[$languages[$i]['id']]['agi_attribute_size'] : '', 'style="width:100%"'); ?></span></td>
          </tr>
          <tr>
            <td><span class="main"><?php echo draw_tooltip(MODULE_AGI_EXPORT_PRODUCTS_TTIP_ATTRIBUT_PATTERN).' '.MODULE_AGI_EXPORT_PRODUCTS_TEXT_ATTRIBUT_PATTERN; ?></span></td>
            <td><span class="main"><?php echo xtc_draw_input_field('agi_attribute_pattern['.$languages[$i]['id'].']', !empty($agi_export_lang_data[$languages[$i]['id']]['agi_attribute_pattern']) ? $agi_export_lang_data[$languages[$i]['id']]['agi_attribute_pattern'] : '', 'style="width:100%"'); ?></span></td>
            <td style="width: 30px"></td>
            <td><span class="main"><?php echo draw_tooltip(MODULE_AGI_EXPORT_PRODUCTS_TTIP_ATTRIBUT_MATERIAL).' '.MODULE_AGI_EXPORT_PRODUCTS_TEXT_ATTRIBUT_MATERIAL; ?></span></td>
            <td><span class="main"><?php echo xtc_draw_input_field('agi_attribute_material['.$languages[$i]['id'].']', !empty($agi_export_lang_data[$languages[$i]['id']]['agi_attribute_material']) ? $agi_export_lang_data[$languages[$i]['id']]['agi_attribute_material'] : '', 'style="width:100%"'); ?></span></td>
          </tr>
        </table>
        <table class="tableInput border0">
          <tr>
            <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_ALTERNATE_TITLE ?></span></td>
            <td colspan="4"><span class="main"><?php echo xtc_draw_input_field('agi_alternate_title['.$languages[$i]['id'].']', !empty($agi_export_lang_data[$languages[$i]['id']]['agi_alternate_title']) ? $agi_export_lang_data[$languages[$i]['id']]['agi_alternate_title'] : '', 'style="width:100%"'); ?></span></td>
          </tr>
          <tr>
            <td style="border-top:1px solid #cdcdcd"><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_GOOGLE_CATEGORY_USED; ?></span>
            <td colspan="4" style="border-top:1px solid #cdcdcd">
              <?php echo xtc_draw_input_field('agi_google_category['.$languages[$i]['id'].']', !empty($agi_export_lang_data[$languages[$i]['id']]['agi_google_category']) ? $agi_export_lang_data[$languages[$i]['id']]['agi_google_category'] : '', 'style="width:100%" id="agi_google_category_'.$languages[$i]['id'].'"'); ?><br />
            </td>
          </tr>
          <tr>
            <td ><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_GOOGLE_CATEGORY_SELECT; ?></span>
            <td colspan="4">
              <?php echo xtc_draw_pull_down_menu('agi_google_taxonomie_select_'.$languages[$i]['id'], $agi_export_google_taxonomie_list[$languages[$i]['code']], array_key_exists($languages[$i]['id'], $agi_export_lang_data) ? $agi_export_lang_data[$languages[$i]['id']]['agi_google_category'] : '', 'style="width:70%;" id="agi_google_taxonomie_select_'.$languages[$i]['id'].'" class="noStyling"'); ?>
              <?php echo '<a href="#" class="button" title="'.MODULE_AGI_EXPORT_GOOGLE_TAXONOMIE_FILLIN_BUTTON.'" onclick="agi_export_fillinGoogleCategory('.$languages[$i]['id'].');return false;">'.MODULE_AGI_EXPORT_GOOGLE_TAXONOMIE_FILLIN_BUTTON.'</a>'; ?>
              <br /><span class="main"><small><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_GOOGLE_CATEGORY_DESC; ?></small></span>
            </td>
          </tr>
          <tr>
            <td style="border-top:1px solid #cdcdcd" colspan="5"><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_HEIGHTLIGHT; ?><br /><small><?php echo MODULE_AGI_EXPORT_PRODUCTS_TTIP_HEIGHTLIGHT; ?></small></span>
              <table class="tableInput border0">
                <?php 
                  $k = 0;
                  while ($k < 10) {
                ?>
                <tr>
                  <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_HEIGHTLIGHT_TITLE.' '.($k+1); ?></span></td>
                  <td><?php echo xtc_draw_input_field('agi_highlight_text['.$languages[$i]['id'].'][]', array_key_exists($languages[$i]['id'], $agi_export_lang_data) ? (array_key_exists($k, $agi_export_lang_data[$languages[$i]['id']]['agi_highlight_text']) ? decode_utf8($agi_export_lang_data[$languages[$i]['id']]['agi_highlight_text'][$k]) : '') : '', 'maxlength="150"'); ?></td>
                  <td style="width: 30px"></td>
                  <?php $k += 1; ?>
                  <td><span class="main"><?php echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_HEIGHTLIGHT_TITLE.' '.($k+1); ?></span></td>
                  <td><?php echo xtc_draw_input_field('agi_highlight_text['.$languages[$i]['id'].'][]', array_key_exists($languages[$i]['id'], $agi_export_lang_data) ? (array_key_exists($k, $agi_export_lang_data[$languages[$i]['id']]['agi_highlight_text']) ? decode_utf8($agi_export_lang_data[$languages[$i]['id']]['agi_highlight_text'][$k]) : '') : '', 'maxlength="150"'); ?></td>
                  <?php $k += 1; ?>
                </tr>
                <?php } ?>
              </table>
            </td>
          </tr>
        </table>
      </div>
    <?php } ?>
    </div>
  </div>
</div>
<script>
function agi_export_showTab(prefix, auswahl, anzahl) { 
  for (var i = 0; i < anzahl; i++) {
    if (document.getElementById) {
      document.getElementById(prefix+"_tab_" +i).style.display="none";	 	       	  
      document.getElementById(prefix+"_tabselect_" +i).style.background="none";
      document.getElementById(prefix+"_tabselect_" +i).style.color="#aaaaaa";		  
      
      if (prefix+"_tab_" + auswahl == prefix+"_tab_" + i) {
        document.getElementById(prefix+"_tab_" + i).style.display="block";			
        
        document.getElementById(prefix+"_tabselect_" +i).style.background="#d0d0d0";
        document.getElementById(prefix+"_tabselect_" +i).style.color="#000000";
      }        
    }	
  }
}
function agi_export_fillinGoogleCategory(language_id) {
  if (document.getElementById('agi_google_category_'+language_id) && document.getElementById('agi_google_taxonomie_select_'+language_id)) {
    var source = document.getElementById('agi_google_taxonomie_select_'+language_id);
    var target = document.getElementById('agi_google_category_'+language_id);
    var category_string = source[source.selectedIndex].value;
    target.value = category_string == '0' ? '' : category_string;
  }
}
$( document ).ready(function() {
  $('#module_agi_export_wrapper').parent('div').append($('#module_agi_export_wrapper').detach());
  $('#module_agi_export_wrapper').show();
});
</script>
<?php
if (file_exists(DIR_FS_ADMIN.'includes/modules/categories/agi_export.php')) {
  require_once DIR_FS_ADMIN.'includes/modules/categories/agi_export.php';
  $cat_agi_export = new agi_export();
  $agi_export_images_attributes = $cat_agi_export -> agi_export_load_products_attributes($pInfo->products_id, (int)$_SESSION['languages_id']);
  $cnt_images = 0;
  if (defined('MO_PICS')) {
    $cnt_images = (int)MO_PICS;
  }
  for ($i=0; $i <= $cnt_images; $i++) {
    echo '<div id="agi_export_image_extender_'.$i.'" style="display:none">';
      echo '<table>';
      echo '<tr><td class="dataTableConfig col-left">'.MODULE_AGI_EXPORT_PRODUCTS_TEXT_IMAGE_GOOGLE_EXPORT_SORTORDER.'</td>';
      echo '<td class="dataTableConfig col-middle">';
      echo draw_on_off_selection('agi_exportimage_active_'.$i, $options_onoff, $cat_agi_export -> agi_export_get_products_image_export_allowed($pInfo->agi_export_image_json, $i));
      echo '<span class="cfg_select_option" style="border:none;background:transparent"> / ';
      echo xtc_draw_input_field('agi_exportimage_sortorder_'.$i, $cat_agi_export -> agi_export_get_products_image_export_sortorder($pInfo->agi_export_image_json, $i), 'size="3" style="width:50px"');
      echo '</td><td class="dataTableConfig col-right">';
      echo MODULE_AGI_EXPORT_PRODUCTS_TEXT_IMAGE_IS_ATTRIBUTS.'<br />'.$cat_agi_export -> agi_export_get_products_image_attribute_selection($agi_export_images_attributes, $pInfo->agi_export_image_json, $i);
      echo '</td></tr>';
      echo '</table>';
    echo '</div>';
  }
  ?>
  <script>
  $(function() {  
    <?php 
      for ($i=0; $i <= $cnt_images; $i++) { 
        if ($i == 0) {
      ?>
        $('#agi_export_image_extender_<?php echo $i; ?> tr:first').detach().appendTo($(document.getElementById('finput_products_image') ? '#finput_products_image' : '#products_image').closest($('table')));
      <?php } else { ?>
        $('#agi_export_image_extender_<?php echo $i; ?> tr:first').detach().appendTo($(document.getElementById('finput_mo_pics_<?php echo $i-1; ?>') ? '#finput_mo_pics_<?php echo $i-1; ?>' : '#mo_pics_<?php echo $i-1; ?>').closest($('table')));
      <?php } ?>
    $('#agi_export_image_extender_<?php echo $i; ?>').detach()
    <?php } ?>
  });
  </script>
  <?php
}