<?php
/* includes/external/agi/agi_export/admin/modules/configurations/module.php
.---------------------------------------------------------------------------.
|    Software: agi_export for modified eCommerce                            |
|      Author: Andreas Guder                                                |
|     Contact: info@andreas-guder.de                                        |
| Copyright (c) 2022, Andreas Guder [info@andreas-guder.de]                 |
|               All Rights Reserved.                                        |
| ------------------------------------------------------------------------- |
|     License: you are not allowed to distribute                            |
|              or sublicense copies of the software without                 |
|              a grant of a licence of the coyright-owner                   |
'---------------------------------------------------------------------------ü
*/
// preload all config-parameter
agi_export_get_config('*');

if (isset($_GET['action']) && $_GET['action'] == 'save') {
  $sql_data_array = array();
  foreach ($_POST['config'] as $key => $value) {
    if (function_exists('agi_export_config_parse_'.$key)) {
      $value = call_user_func('agi_export_config_parse_'.$key, $value);
    }
    if (!array_key_exists($key, $_agi_export_config)) {
      $qr = xtc_db_query("SELECT * FROM `agi_export_config` WHERE `config_key`='".xtc_db_input($key)."'");
      if (!xtc_db_num_rows($qr)) {
        xtc_db_perform('agi_export_config', array('config_key'=>$key, 'config_value' => $value, 'configured'=>1));
      }
      xtc_db_free_result($qr);
    }
    xtc_db_perform('agi_export_config', array('config_value' => $value, 'configured'=>1), "update", "`config_key`='".xtc_db_input($key)."'");
  }
  if (agi_export_get_config('preselect_condition') != $_POST['config']['preselect_condition']) {
    xtc_db_query("ALTER TABLE `".TABLE_PRODUCTS."` CHANGE `agi_export_condition` `agi_export_condition` varchar(32) NOT NULL DEFAULT '".xtc_db_input($_POST['config']['preselect_condition'])."'");
  }
  if (agi_export_get_config('preselect_clothing_product') != $_POST['config']['preselect_clothing_product']) {
    xtc_db_query("ALTER TABLE `".TABLE_PRODUCTS."` CHANGE `agi_is_clothing_product` `agi_is_clothing_product` tinyint(1) NOT NULL DEFAULT ".($_POST['config']['preselect_clothing_product'] ? '1' : '0'));
  }
  if (agi_export_get_config('preselect_identifier_exists') != $_POST['config']['preselect_identifier_exists']) {
    xtc_db_query("ALTER TABLE `".TABLE_PRODUCTS."` CHANGE `agi_identifier_exists` `agi_identifier_exists` tinyint(1) NOT NULL DEFAULT ".($_POST['config']['preselect_identifier_exists'] ? '1' : '0'));
  }
  $messageStack->add_session(MODULE_AGI_EXPORT_MESSAGE_CONFIGURATION_SAVED, 'success');
  xtc_redirect(xtc_href_link(basename($PHP_SELF), xtc_get_all_get_params(array('action'))));
}

$options_onoff = array(
  array('id' => 1, 'text' => YES),
  array('id' => 0, 'text' => NO)
);
$options_availability = array(
  array('id' => 'IN_STOCK', 'text' => MODULE_AGI_EXPORT_PRODUCTS_AVAILABLE_BASE_ALWAYSON), 
  array('id' => 'QUANTITY', 'text' => MODULE_AGI_EXPORT_PRODUCTS_AVAILABLE_BASE_QUANTITY),
  array('id' => 'SHIPPING_TIME', 'text' => MODULE_AGI_EXPORT_PRODUCTS_AVAILABLE_BASE_SHIPPING)
);
$options_conditions = array(
  array('id' => 'new', 'text' => MODULE_AGI_EXPORT_PRODUCTS_STATUS_NEW), 
  array('id' => 'used', 'text' => MODULE_AGI_EXPORT_PRODUCTS_STATUS_USED),
  array('id' => 'refurbished', 'text' => MODULE_AGI_EXPORT_PRODUCTS_STATUS_REFURBISHED)
);
$options_shippingbase = array(
  array('id' => 'price', 'text' => MODULE_AGI_EXPORT_PRODUCTS_SHIPPINGBASE_PRICE), 
  array('id' => 'weight', 'text' => MODULE_AGI_EXPORT_PRODUCTS_SHIPPINGBASE_WEIGHT)
);
$options_products_image = array(
  array('id' => 'popup_images', 'text' => 'Popup Images'), 
  array('id' => 'info_images', 'text' => 'Info Images'),
  array('id' => 'original_images', 'text' => 'Original Images')  
);
$options_products_desc = array(
  array('id' => 'long', 'text' => MODULE_AGI_EXPORT_PRODUCTS_USEDESC_DEFAULT), 
  array('id' => 'short', 'text' => MODULE_AGI_EXPORT_PRODUCTS_USEDESC_SHORT)
);
$options_size_system = array(
  array('id' => 'EU', 'text' => 'EU'),
  array('id' => 'DE', 'text' => 'DE'),
  array('id' => 'US', 'text' => 'US'),
  array('id' => 'UK', 'text' => 'UK'),
  array('id' => 'FR', 'text' => 'FR'),
  array('id' => 'JP', 'text' => 'JP'),
  array('id' => 'CN', 'text' => 'CN'),
  array('id' => 'IT', 'text' => 'IT'),
  array('id' => 'BR', 'text' => 'BR'),
  array('id' => 'MEX', 'text' => 'MEX'),
  array('id' => 'AU', 'text' => 'AU')
);
$options_gender = array(
  array('id' => '', 'text' => '-'),
  array('id' => 'unisex', 'text' => MODULE_AGI_EXPORT_PRODUCTS_GENDER_UNISEX),
  array('id' => 'female', 'text' => MODULE_AGI_EXPORT_PRODUCTS_GENDER_FEMALE),
  array('id' => 'male', 'text' => MODULE_AGI_EXPORT_PRODUCTS_GENDER_MALE)
);
$options_agegroup = array(
  array('id' => '', 'text' => '-'),
  array('id' => 'adult', 'text' => MODULE_AGI_EXPORT_PRODUCTS_AGEGROUP_ADULT),
  array('id' => 'kids', 'text' => MODULE_AGI_EXPORT_PRODUCTS_AGEGROUP_KIDS),
  array('id' => 'newborn', 'text' => MODULE_AGI_EXPORT_PRODUCTS_AGEGROUP_NEWBORN),
  array('id' => 'infant', 'text' => MODULE_AGI_EXPORT_PRODUCTS_AGEGROUP_INFANT),
  array('id' => 'toddler', 'text' => MODULE_AGI_EXPORT_PRODUCTS_AGEGROUP_TODDLER)
);
$options_sizetype = array(
  array('id' => 'regular', 'text' => MODULE_AGI_EXPORT_PRODUCTS_SIZETYP_REGULAR),
  array('id' => 'petite', 'text' => MODULE_AGI_EXPORT_PRODUCTS_SIZETYP_PETITE),
  array('id' => 'plus', 'text' => MODULE_AGI_EXPORT_PRODUCTS_SIZETYP_PLUS),
  array('id' => 'maternity', 'text' => MODULE_AGI_EXPORT_PRODUCTS_SIZETYP_MATERNITY)
);
$options_shipping_avail = array(
  array('id' => 'in stock', 'text' => MODULE_AGI_EXPORT_PRODUCTS_AVAILABLE_INSTOCK), 
  array('id' => 'out of stock', 'text' => MODULE_AGI_EXPORT_PRODUCTS_AVAILABLE_SOLD),
  array('id' => 'preorder', 'text' => MODULE_AGI_EXPORT_PRODUCTS_AVAILABLE_PREORDER),
  array('id' => 'backorder', 'text' => MODULE_AGI_EXPORT_PRODUCTS_AVAILABLE_BACKORDER)
);

$tmp = agi_export_get_config('map_shipping_to_status');
$_shipping_avail = empty($tmp) ? array() : json_decode($tmp, true);
$shipping_statuses = array ();
$shipping_statuses = xtc_get_shipping_status();
