<?php
/* includes/external/agi/agi_export/admin/modules/feeds/module.php
.---------------------------------------------------------------------------.
|    Software: agi_export for modified eCommerce                            |
|      Author: Andreas Guder                                                |
|     Contact: info@andreas-guder.de                                        |
| Copyright (c) 2022, Andreas Guder [info@andreas-guder.de]                 |
|               All Rights Reserved.                                        |
| ------------------------------------------------------------------------- |
|     License: you are not allowed to distribute                            |
|              or sublicense copies of the software without                 |
|              a grant of a licence of the coyright-owner                   |
'---------------------------------------------------------------------------ü
*/
  $_action = isset($_GET['action']) ? $_GET['action'] : '';
  $languages = xtc_get_languages();
  
  if ($_action == 'save' && isset($_GET['set']) && !empty($_GET['set']) && (preg_match('/^\d+$/', $_GET['set']) || $_GET['set'] == 'new')) {
    $sql_data = array(
      'name'            => $_POST['agi_feed_name'],
      'file_name'       => agi_url_cleaned_name(empty($_POST['agi_feed_file_name']) ? $_POST['agi_feed_name'].'.txt' : $_POST['agi_feed_file_name']),
      'description'     => $_POST['agi_feed_desc'],
      'status'          => (int)$_POST['agi_feed_status'],
      'type'            => $_POST['agi_feed_type'],
      'cron'            => (int)$_POST['agi_feed_cron'],
      'export_allowed'  => (int)$_POST['agi_export_allowed'],
      'export_attributes' => (int)$_POST['agi_export_attributes'],
      'export_graduated_price' => (int)$_POST['agi_export_graduated_price'],
      'language'        => (int)$_POST['agi_feed_language'],
      'country'         => preg_replace('/[^A-Za-z,]/', '', $_POST['agi_feed_country']),
      'customers_group' => (int)$_POST['agi_feed_cgroup'],
      'currency'        => $_POST['agi_feed_currency'],
      'last_modified'   => 'NOW()',
      'products_filter' => '',
      'google_settings' => ''
    );
    if (empty($sql_data['file_name'])) {
      $sql_data['file_name'] = uniqid();
    }
    if (!empty($sql_data['country'])) {
      $c_given = explode(',', $sql_data['country']);
      $c_list = array();
      foreach ($c_given as $row) {
        $tmp = preg_replace('/\s/', '', $row);
        if (!empty($tmp)) {
          $c_list[] = strtoupper($tmp);
        }
      }
      if (!empty($c_list)) {
        $sql_data['country'] = implode(',', $c_list);
      }
    }
    if (empty($sql_data['country'])) {
      $query = xtc_db_query("SELECT `countries_iso_code_2` FROM `".TABLE_COUNTRIES."` WHERE `countries_id`='".STORE_COUNTRY."' LIMIT 0,1");
      $tmp = xtc_db_fetch_array($query);
      $sql_data['country'] = $tmp['countries_iso_code_2'];
    }
    
    $p_filter = array(
      'addprice'  => 0,
      'minprice'  => 0,
      'maxprice'  => 0,
      'minstock'  => 0,
      'fsk18'     => 0,
      'include_manu' => '',
      'exclude_manu' => '',
      'include_stimes' => '',
      'exclude_stimes' => ''
    );
    if (!empty($_POST['agi_feed_pfilter']['addprice']) && preg_match('/^[0-9,.\-]{1,}$/', $_POST['agi_feed_pfilter']['addprice'])) {
      $p_filter['addprice'] = str_replace(',', '.', $_POST['agi_feed_pfilter']['addprice']);
    }
    if (!empty($_POST['agi_feed_pfilter']['minprice']) && preg_match('/^[0-9,.\-]{1,}$/', $_POST['agi_feed_pfilter']['minprice'])) {
      $p_filter['minprice'] = str_replace(',', '.', $_POST['agi_feed_pfilter']['minprice']);
    }
    if (!empty($_POST['agi_feed_pfilter']['maxprice']) && preg_match('/^[0-9,.\-]{1,}$/', $_POST['agi_feed_pfilter']['maxprice'])) {
      $p_filter['maxprice'] = str_replace(',', '.', $_POST['agi_feed_pfilter']['maxprice']);
    }
    if (!empty($_POST['agi_feed_pfilter']['minstock']) && preg_match('/^[0-9]{1,}$/', $_POST['agi_feed_pfilter']['minstock'])) {
      $p_filter['minstock'] = (int)$_POST['agi_feed_pfilter']['minstock'];
    }
    if (!empty($_POST['agi_feed_pfilter']['fsk18'])) {
      $p_filter['fsk18'] = (int)$_POST['agi_feed_pfilter']['fsk18'];
    }
    if (!empty($_POST['agi_feed_pfilter']['exclude_manu']) && is_array($_POST['agi_feed_pfilter']['exclude_manu'])) {
      $list = array();
      foreach ($_POST['agi_feed_pfilter']['exclude_manu'] as $value) {
        $list[] = (int)$value;
      }
      if (!empty($list)) {
        $p_filter['exclude_manu'] = implode(',', array_unique($list));
      }
    } elseif (!empty($_POST['agi_feed_pfilter']['exclude_manu']) && preg_match('/^[0-9, ]{1,}$/', $_POST['agi_feed_pfilter']['exclude_manu'])) {
      $p_filter['exclude_manu'] = preg_replace('/\s/', '', $_POST['agi_feed_pfilter']['exclude_manu']);
    }
    if (!empty($_POST['agi_feed_pfilter']['include_manu']) && is_array($_POST['agi_feed_pfilter']['include_manu'])) {
      $list = array();
      foreach ($_POST['agi_feed_pfilter']['include_manu'] as $value) {
        $list[] = (int)$value;
      }
      if (!empty($list)) {
        $p_filter['include_manu'] = implode(',', array_unique($list));
      }
    } elseif (!empty($_POST['agi_feed_pfilter']['include_manu']) && preg_match('/^[0-9, ]{1,}$/', $_POST['agi_feed_pfilter']['include_manu'])) {
      $p_filter['include_manu'] = preg_replace('/\s/', '', $_POST['agi_feed_pfilter']['include_manu']);
    }
    if (!empty($_POST['agi_feed_pfilter']['include_stimes']) && is_array($_POST['agi_feed_pfilter']['include_stimes'])) {
      $list = array();
      foreach ($_POST['agi_feed_pfilter']['include_stimes'] as $value) {
        $list[] = (int)$value;
      }
      if (!empty($list)) {
        $p_filter['include_stimes'] = implode(',', array_unique($list));
      }
    } elseif (!empty($_POST['agi_feed_pfilter']['include_stimes']) && preg_match('/^[0-9, ]{1,}$/', $_POST['agi_feed_pfilter']['include_stimes'])) {
      $p_filter['include_stimes'] = preg_replace('/\s/', '', $_POST['agi_feed_pfilter']['include_stimes']);
    }
    if (!empty($_POST['agi_feed_pfilter']['exclude_stimes']) && is_array($_POST['agi_feed_pfilter']['exclude_stimes'])) {
      $list = array();
      foreach ($_POST['agi_feed_pfilter']['exclude_stimes'] as $value) {
        $list[] = (int)$value;
      }
      if (!empty($list)) {
        $p_filter['exclude_stimes'] = implode(',', array_unique($list));
      }
    } elseif (!empty($_POST['agi_feed_pfilter']['exclude_stimes']) && preg_match('/^[0-9, ]{1,}$/', $_POST['agi_feed_pfilter']['exclude_stimes'])) {
      $p_filter['exclude_stimes'] = preg_replace('/\s/', '', $_POST['agi_feed_pfilter']['exclude_stimes']);
    }
    $sql_data['products_filter'] = $p_filter;
    
    if ($sql_data['type'] == 'google_xml') {
      $g_setting = array(
        'do_shipping'  => 0
      );
      if (!empty($_POST['agi_feed_gsetting']['do_shipping'])) {
        $g_setting['do_shipping'] = (int)$_POST['agi_feed_gsetting']['do_shipping'];
      }
      $sql_data['google_settings'] = $g_setting;
    }
    
    foreach(auto_include(DIR_FS_EXTERNAL.'agi/agi_export/autoinclude/admin/module/feeds_edit/save/','php') as $file) require ($file);
    
    $sql_data['products_filter'] = !empty($sql_data['products_filter']) ? json_encode($sql_data['products_filter'], JSON_UNESCAPED_UNICODE) : '';
    $sql_data['google_settings'] = !empty($sql_data['google_settings']) ? json_encode($sql_data['google_settings'], JSON_UNESCAPED_UNICODE) : '';
    
    if ($_GET['set'] == 'new') {
      $sql_data['date_added'] = 'NOW()';
      xtc_db_perform('agi_export_feeds', $sql_data);
      $_GET['set'] = xtc_db_insert_id();
      xtc_db_query("ALTER TABLE `".TABLE_PRODUCTS."` ADD `agi_export_feed_".$_GET['set']."` TINYINT(1) NOT NULL DEFAULT ".($_POST['agi_export_allowed'] ? '1' : '0').", ADD `agi_export_feed_".$_GET['set']."_inputs` TEXT NULL DEFAULT NULL");
      if (isset($_POST['set_export_allowed_on_existing_products']) && !$sql_data['export_allowed']) {
        xtc_db_query("UPDATE `".TABLE_PRODUCTS."` SET `agi_export_feed_".$_GET['set']."`=".($sql_data['export_allowed'] ? '1' : '0'));
      }
    } else {
      
      $query_result = xtc_db_query("SHOW COLUMNS FROM `" . TABLE_PRODUCTS . "`");
      $db_table_rows = array();
      while ($row = xtc_db_fetch_array($query_result)) {
        $db_table_rows[] = $row['Field'];
      }
      if (!in_array('agi_export_feed_'.$_GET['set'], $db_table_rows)) {
        xtc_db_query("ALTER TABLE `".TABLE_PRODUCTS."` ADD `agi_export_feed_".$_GET['set']."` TINYINT(1) NOT NULL DEFAULT ".($sql_data['export_allowed'] ? '1' : '0'));
      }
      if (!in_array('agi_export_feed_'.$_GET['set'].'_inputs', $db_table_rows)) {
        xtc_db_query("ALTER TABLE `".TABLE_PRODUCTS."` ADD `agi_export_feed_".$_GET['set']."_inputs` TEXT NULL DEFAULT NULL");
      }
      
      $qr = xtc_db_query("SELECT `export_allowed` FROM `agi_export_feeds` WHERE `id`=".$_GET['set']);
      $tmp = xtc_db_fetch_array($qr);
      xtc_db_perform('agi_export_feeds', $sql_data, 'update', "`id`=".$_GET['set']);
      if ($tmp['export_allowed'] != $sql_data['export_allowed']) {
        xtc_db_query("ALTER TABLE `".TABLE_PRODUCTS."` CHANGE `agi_export_allowed` `agi_export_allowed` TINYINT(1) NOT NULL DEFAULT ".($sql_data['export_allowed'] ? '1' : '0'));
      }
      if (isset($_POST['set_export_allowed_on_existing_products'])) {
        xtc_db_query("UPDATE `".TABLE_PRODUCTS."` SET `agi_export_feed_".$_GET['set']."`=".($sql_data['export_allowed'] ? '1' : '0'));
      }
      if ($sql_data['cron']) {
        xtc_db_perform('agi_export_feeds', array('in_process' => '0000-00-00 00:00:00', 'cron_last_pid'=>0, 'quick_in_process' => '0000-00-00 00:00:00', 'quick_cron_last_pid'=>0), 'update', "`id`=".$_GET['set']);
        if (file_exists(DIR_FS_EXTERNAL.'agi/agi_export/feeds/feed_'.$_GET['set'].'.tmp')) {
          @unlink(DIR_FS_EXTERNAL.'agi/agi_export/feeds/feed_'.$_GET['set'].'.tmp');
        }
        if (file_exists(DIR_FS_EXTERNAL.'agi/agi_export/feeds/feed_'.$_GET['set'].'.quick.tmp')) {
          @unlink(DIR_FS_EXTERNAL.'agi/agi_export/feeds/feed_'.$_GET['set'].'.quick.tmp');
        }
      }
    }
    $messageStack->add_session(MODULE_AGI_EXPORT_MESSAGE_FEED_SAVED, 'success');
    xtc_redirect(xtc_href_link(basename($PHP_SELF), xtc_get_all_get_params(array('action'))));
  }
  
  $country_iso = 'DE';
  $qr = xtc_db_query("SELECT `countries_iso_code_2` FROM `".TABLE_COUNTRIES."` WHERE `countries_id`='".STORE_COUNTRY."' LIMIT 0,1");
  if (xtc_db_num_rows($qr)) {
    $tmp = xtc_db_fetch_array($qr);
    if (!empty($tmp)) {
      $country_iso = $tmp['countries_iso_code_2'];
    }
  }
  $feeds_entry = array(
    'id'              => 0,
    'name'            => MODULE_AGI_EXPORT_FEEDS_TEXT_NEW_FEED,
    'type'            => 'google_xml',
    'status'          => 1,
    'export_allowed'  => 1,
    'export_attributes'=> 1,
    'export_graduated_price'=>0,
    'file_name'       => '',
    'description'     => '',
    'cron'            => 0,
    'language'        => $_SESSION['languages_id'],
    'country'         => $country_iso,
    'currency'        => DEFAULT_CURRENCY,
    'customers_group' => DEFAULT_CUSTOMERS_STATUS_ID_GUEST,
    'campaign'        => 0,
    'products_filter' => '',
    'google_settings' => '',
    'csv_fields'      => '',
    'csv_settings'    => '',
    'input_fields'    => ''
  );
  if (isset($_GET['set']) && !empty($_GET['set']) && preg_match('/^\d+$/', $_GET['set'])) {
    if ($_action == 'clear_cache') {
      // load in_process
      $qr = xtc_db_query("SELECT `in_process`,`quick_in_process` FROM `agi_export_feeds` WHERE `id`=".$_GET['set']);
      $tmp = xtc_db_fetch_array($qr);
      if ($tmp['in_process'] != '0000-00-00 00:00:00' || $tmp['quick_in_process'] != '0000-00-00 00:00:00') {
        xtc_db_perform('agi_export_feeds', array('clear_after_process'=>1), 'update', "`id`=".$_GET['set']);
      }
      if (file_exists(DIR_FS_EXTERNAL.'agi/agi_export/feeds/feed_'.$_GET['set'].'.final')) {
        @unlink(DIR_FS_EXTERNAL.'agi/agi_export/feeds/feed_'.$_GET['set'].'.final');
      }
      if (file_exists(DIR_FS_EXTERNAL.'agi/agi_export/feeds/feed_'.$_GET['set'].'.tmp')) {
        @unlink(DIR_FS_EXTERNAL.'agi/agi_export/feeds/feed_'.$_GET['set'].'.tmp');
      }
      if (file_exists(DIR_FS_EXTERNAL.'agi/agi_export/feeds/feed_'.$_GET['set'].'.quick.final')) {
        @unlink(DIR_FS_EXTERNAL.'agi/agi_export/feeds/feed_'.$_GET['set'].'.quick.final');
      }
      if (file_exists(DIR_FS_EXTERNAL.'agi/agi_export/feeds/feed_'.$_GET['set'].'.quick.tmp')) {
        @unlink(DIR_FS_EXTERNAL.'agi/agi_export/feeds/feed_'.$_GET['set'].'.quick.tmp');
      }
      $messageStack->add_session(MODULE_AGI_EXPORT_MESSAGE_FEED_CACHE_CLEARED, 'success');
      xtc_redirect(xtc_href_link(basename($PHP_SELF), xtc_get_all_get_params(array('action'))));
    } 
    elseif ($_action == 'reset_cron') {
      // load in_process
      $qr = xtc_db_query("SELECT `in_process`,`quick_in_process` FROM `agi_export_feeds` WHERE `id`=".$_GET['set']);
      $tmp = xtc_db_fetch_array($qr);
      if ($tmp['in_process'] != '0000-00-00 00:00:00' || $tmp['quick_in_process'] != '0000-00-00 00:00:00') {
        $sql_data = array('clear_after_process'=>1);
      } else {
        $sql_data = array('in_process' => '0000-00-00 00:00:00', 'cron_last_pid'=>0, 'quick_in_process' => '0000-00-00 00:00:00', 'quick_cron_last_pid'=>0);
      }
      xtc_db_perform('agi_export_feeds', $sql_data, 'update', "`id`=".$_GET['set']);
      if (file_exists(DIR_FS_EXTERNAL.'agi/agi_export/feeds/feed_'.$_GET['set'].'.tmp')) {
        @unlink(DIR_FS_EXTERNAL.'agi/agi_export/feeds/feed_'.$_GET['set'].'.tmp');
      }
      if (file_exists(DIR_FS_EXTERNAL.'agi/agi_export/feeds/feed_'.$_GET['set'].'.quick.tmp')) {
        @unlink(DIR_FS_EXTERNAL.'agi/agi_export/feeds/feed_'.$_GET['set'].'.quick.tmp');
      }
      $messageStack->add_session(MODULE_AGI_EXPORT_MESSAGE_FEED_CRON_RESETTED, 'success');
      xtc_redirect(xtc_href_link(basename($PHP_SELF), xtc_get_all_get_params(array('action'))));
    } 
    elseif ($_action == 'removeconfirm' && isset($_POST['checkagain']) && $_POST['checkagain'] == $_GET['set'] && $_GET['set'] > 1) {
      if (file_exists(DIR_FS_EXTERNAL.'agi/agi_export/feeds/feed_'.$_GET['set'].'.final')) {
        @unlink(DIR_FS_EXTERNAL.'agi/agi_export/feeds/feed_'.$_GET['set'].'.final');
      }
      if (file_exists(DIR_FS_EXTERNAL.'agi/agi_export/feeds/feed_'.$_GET['set'].'.quick.final')) {
        @unlink(DIR_FS_EXTERNAL.'agi/agi_export/feeds/feed_'.$_GET['set'].'.quick.final');
      }
      xtc_db_query("DELETE FROM `agi_export_feeds` WHERE `id`=".(int)$_GET['set']);
      xtc_db_query("ALTER TABLE `".TABLE_PRODUCTS."` DROP `agi_export_feed_".(int)$_GET['set']."`, DROP agi_export_feed_".(int)$_GET['set']."_inputs`");
      $messageStack->add_session(MODULE_AGI_EXPORT_MESSAGE_FEED_DELETED, 'success');
      xtc_redirect(xtc_href_link(basename($PHP_SELF), xtc_get_all_get_params(array('action','set'))));
    }
    
    // load feed-row from database
    $qr = xtc_db_query("SELECT * FROM `agi_export_feeds` WHERE `id`=".(int)$_GET['set']);
    if (xtc_db_num_rows($qr)) {
      $feeds_entry = xtc_db_fetch_array($qr);
    }
    xtc_db_free_result($qr);
  }
