<?php
/* includes/external/agi/agi_export/admin/modules/feeds/template.php
.---------------------------------------------------------------------------.
|    Software: agi_export for modified eCommerce                            |
|      Author: Andreas Guder                                                |
|     Contact: info@andreas-guder.de                                        |
| Copyright (c) 2022, Andreas Guder [info@andreas-guder.de]                 |
|               All Rights Reserved.                                        |
| ------------------------------------------------------------------------- |
|     License: you are not allowed to distribute                            |
|              or sublicense copies of the software without                 |
|              a grant of a licence of the coyright-owner                   |
'---------------------------------------------------------------------------ü
*/
?>
<br />
<?php if (!isset($_action) || (isset($_action) && (empty($_action) || in_array($_action, array('remove'))))) { ?>
<table class="tableCenter">
  <tr>
    <td class="boxCenterLeft">
      <table class="tableBoxCenter collapse">
        <tr class="dataTableHeadingRow">
          <td class="dataTableHeadingContent"><?php echo MODULE_AGI_EXPORT_FEEDS_TEXT_ID; ?></td>
          <td class="dataTableHeadingContent"><?php echo MODULE_AGI_EXPORT_FEEDS_TEXT_NAME; ?></td>
          <td class="dataTableHeadingContent"><?php echo MODULE_AGI_EXPORT_FEEDS_TEXT_DESC; ?></td>
          <td class="dataTableHeadingContent"><?php echo MODULE_AGI_EXPORT_FEEDS_TEXT_TYPE; ?></td>
          <td class="dataTableHeadingContent"><?php echo MODULE_AGI_EXPORT_FEEDS_TEXT_FILENAME; ?></td>
          <td class="dataTableHeadingContent txta-c"><?php echo MODULE_AGI_EXPORT_FEEDS_TEXT_STATUS; ?></td>
          <td class="dataTableHeadingContent txta-r"><?php echo MODULE_AGI_EXPORT_FEEDS_TEXT_ACTION; ?></td>
        </tr>
<?php
  // load all profiles
  $profiles = array();
  $qr = xtc_db_query("SELECT * FROM `agi_export_feeds`");
  while ($row = xtc_db_fetch_array($qr)) {
    $profiles[$row['id']] = $row;
  }
  foreach ($profiles as $key => $profile) {
    if (isset($_GET['set']) && $_GET['set'] == $key) {
      $tr_attribute = 'class="dataTableRowSelected" onmouseover="this.style.cursor=\'pointer\'" onclick="document.location.href=\'' . xtc_href_link(basename($PHP_SELF), xtc_get_all_get_params(array('set')).'set='.$key.'&action=edit') . '\'"';
    } else {
      $tr_attribute = 'class="dataTableRow" onmouseover="this.className=\'dataTableRowOver\';this.style.cursor=\'pointer\'" onmouseout="this.className=\'dataTableRow\'" onclick="document.location.href=\'' . xtc_href_link(basename($PHP_SELF), xtc_get_all_get_params(array('action','set')).'set='.$key) . '\'"';
    }
?>
    <tr <?php echo $tr_attribute;?>>
      <td class="dataTableContent"><?php echo encode_htmlentities($profile['id']); ?></td>
      <td class="dataTableContent"><?php echo encode_htmlentities($profile['name']); ?></td>
      <td class="dataTableContent"><?php echo encode_htmlentities($profile['description']); ?></td>
      <td class="dataTableContent"><?php echo encode_htmlentities($profile['type']); ?></td>
      <td class="dataTableContent"><?php echo encode_htmlentities($profile['file_name']); ?></td>
      <td class="dataTableContent txta-c">
      <?php
        if ($profile['status']) {
          echo xtc_image(DIR_WS_IMAGES . 'icon_lager_green.gif', ICON_ARROW_RIGHT);
        } else {
          echo xtc_image(DIR_WS_IMAGES . 'icon_lager_red.gif', ICON_ARROW_RIGHT);
        }
      ?>
      </td>
      <td class="dataTableContent txta-r">
      <?php 
        if (isset($_GET['set']) && $_GET['set'] == $key) {
          echo xtc_image(DIR_WS_IMAGES . 'icon_arrow_right.gif', ICON_ARROW_RIGHT); 
        } else {
          echo '<a href="' . xtc_href_link(basename($PHP_SELF), xtc_get_all_get_params(array('action','set')).'set='.$key) . '">' . xtc_image(DIR_WS_IMAGES . 'icon_arrow_grey.gif', IMAGE_ICON_INFO) . '</a>';
        }
      ?>
      &nbsp;</td>
    </tr>
<?php } ?>
      </table>
      <div class="smallText pdg2 flt-r">
        <a class="button" href="<?php echo xtc_href_link(basename($PHP_SELF), xtc_get_all_get_params(array('action','set')).'action=edit&set=new'); ?>"><?php echo BUTTON_INSERT; ?></a>
      </div>
    </td>
    <td class="boxRight">
      <div class="modulbox">
      <?php 
        $add_feed_password = agi_export_get_config('feed_password');
        if (!empty($add_feed_password)) {
          $add_feed_password = '&pass='.$add_feed_password;
        }
        if (isset($feeds_entry) && $feeds_entry['id'] > 0) {
          $heading = array(array('text' => '<b>'.encode_htmlentities($feeds_entry['name']).'</b>'));
          $contents = array();
          if (empty($_action)) {
            $buttons = array();
            $buttons[] = '<a class="button btnbox" onclick="this.blur();" href="' . xtc_href_link(basename($PHP_SELF), xtc_get_all_get_params(array('action')).'action=edit') . '">' . BUTTON_EDIT . '</a>';
            $buttons[] = '<a class="button btnbox" onclick="this.blur();" href="' . xtc_href_link(basename($PHP_SELF), xtc_get_all_get_params(array('action')).'action=clear_cache') . '">' . MODULE_AGI_EXPORT_FEEDS_BUTTON_CLEAR_CACHE . '</a>';
            if ($feeds_entry['cron']) {
              $buttons[] = '<a class="button btnbox" onclick="this.blur();" href="' . xtc_href_link(basename($PHP_SELF), xtc_get_all_get_params(array('action')).'action=reset_cron') . '">' . MODULE_AGI_EXPORT_FEEDS_BUTTON_RESET_CRON . '</a>';
            }
            if ($feeds_entry['id'] > 1) {
              $buttons[] = '<a class="button btnbox" onclick="this.blur();" href="' . xtc_href_link(basename($PHP_SELF), xtc_get_all_get_params(array('action')).'action=remove') . '">' . BUTTON_DELETE . '</a>';
            }
            if (file_exists(DIR_FS_EXTERNAL.'agi/agi_export/feeds/feed_'.$feeds_entry['id'].'.part')) {
              $buttons[] = '<a class="button btnbox" onclick="this.blur();" href="' . xtc_href_link('/export/agi_export.php', 'feed='.$feeds_entry['id'].$add_feed_password) . '">' . MODULE_AGI_EXPORT_FEEDS_BUTTON_DOWNLOAD_FEED . '</a>';
            }
            $contents[] = array('align' => 'center', 'text' => implode(' ', $buttons));
            
            $lang = '';
            $qr = xtDBquery("SELECT `name` FROM " . TABLE_LANGUAGES . " WHERE `languages_id` = '" . (int)$feeds_entry['language'] . "'");
            if (xtc_db_num_rows($qr, true)) {
              $tmp = xtc_db_fetch_array($qr, true);
              $lang = $tmp['name'];
            }
            
            $contents[] = array('align' => 'left', 'text' => MODULE_AGI_EXPORT_FEEDS_TEXT_LANGUAGE.' '.$lang);
            $contents[] = array('align' => 'left', 'text' => MODULE_AGI_EXPORT_FEEDS_TEXT_COUNTRY.' '.$feeds_entry['country']);
            $contents[] = array('align' => 'left', 'text' => MODULE_AGI_EXPORT_FEEDS_TEXT_CUSTOMER.' '.xtc_get_customers_status_name($feeds_entry['customers_group']));
            $contents[] = array('align' => 'left', 'text' => MODULE_AGI_EXPORT_FEEDS_TEXT_CURRENCY.' '.$feeds_entry['currency']);
            $contents[] = array('align' => 'left', 'text' => MODULE_AGI_EXPORT_FEEDS_TEXT_CRONCALL.' '.($feeds_entry['cron'] ? YES : NO));
            if ($feeds_entry['cron']) {
              $contents[] = array('align' => 'left', 'text' => MODULE_AGI_EXPORT_FEEDS_TEXT_CRON_URI.' '.HTTPS_SERVER.DIR_WS_CATALOG.'export/agi_export.php?croncall=1&feed='.$feeds_entry['id'].$add_feed_password);
            }
            $contents[] = array('align' => 'left', 'text' => ($feeds_entry['cron'] ? MODULE_AGI_EXPORT_FEEDS_TEXT_DOWNLOAD_URI : MODULE_AGI_EXPORT_FEEDS_TEXT_CREATION_URI).' '.HTTPS_SERVER.DIR_WS_CATALOG.'export/agi_export.php?feed='.$feeds_entry['id'].$add_feed_password);
          }
          else {
            if ($_action == 'remove') {
              $contents = array('form' => xtc_draw_form('modules', basename($PHP_SELF), xtc_get_all_get_params(array('action')). '&action=removeconfirm'));
              $contents[] = array('text' => '<br />'.MODULE_AGI_EXPORT_FEEDS_TEXT_REMOVE_CONFIRM);
              $contents[] = array('align' => 'center', 'text' => '<br /><input type="hidden" value="'.$feeds_entry['id'].'" name="checkagain" /><input type="submit" class="button" onclick="this.blur();" value="'. BUTTON_DELETE .'"><a class="button" onclick="this.blur();" href="'.xtc_href_link(basename($PHP_SELF), xtc_get_all_get_params(array('action')).'">' . BUTTON_CANCEL . '</a><br/><br/>'));
            }
          }
          $box = new box;
          echo $box->infoBox($heading, $contents);
        }
      ?>
      </div>
    </td>
  </tr>
</table>
<?php } else { ?>
<table class="tableCenter">
  <tr>
    <td class="boxRight">
      <div class="modulbox" id="agi_feed_settings">
      <?php
        $heading = array(array('text' => '<b>'.encode_htmlentities($feeds_entry['name']).'</b>'));
        $contents = array('form' => xtc_draw_form('modules', basename($PHP_SELF), xtc_get_all_get_params(array('action')). '&action=save'));
        
        $options_onoff = array(
          array('id' => 1, 'text' => YES),
          array('id' => 0, 'text' => NO)
        );
        $options_google_feedtype = array(
          array('id' => 'google_xml', 'text' => MODULE_AGI_EXPORT_FEEDS_TEXT_FEED_TYPE_GOOGLE),
          array('id' => 'csv', 'text' => MODULE_AGI_EXPORT_FEEDS_TEXT_FEED_TYPE_CSV)
        );
        $options_feed_languages = array();
        $qr = xtc_db_query("SELECT `languages_id`, `name` FROM ".TABLE_LANGUAGES." WHERE `status`=1");
        while ($row = xtc_db_fetch_array($qr)) {
          $options_feed_languages[] = array('id' => $row['languages_id'], 'text' => encode_htmlentities($row['name']));
        }
        
        $options_feed_currencys = array();
        $qr = xtc_db_query("SELECT `currencies_id`, `code` FROM ".TABLE_CURRENCIES);
        while ($row = xtc_db_fetch_array($qr)) {
          $options_feed_currencys[] = array('id' => $row['currencies_id'], 'text' => encode_htmlentities($row['code']));
        }
        
        $options_feed_cgroups = array();
        $qr = xtc_db_query("SELECT `customers_status_id`, `customers_status_name` FROM ".TABLE_CUSTOMERS_STATUS." WHERE `language_id`=".(int)$_SESSION['languages_id']);
        while ($row = xtc_db_fetch_array($qr)) {
          $options_feed_cgroups[] = array('id' => $row['customers_status_id'], 'text' => encode_htmlentities($row['customers_status_name']));
        }
        
        $content_table = '<table id="agi_export_global_feed_settings">';
        $content_table .= '<tr>';
        $content_table .= '<td><b>'.MODULE_AGI_EXPORT_FEEDS_TEXT_TYPE.'</b><br />'.xtc_draw_pull_down_menu('agi_feed_type', $options_google_feedtype, $feeds_entry['type'], 
        'id="agi_export_feeds_switch_feed_type"').'<br /><br /></td>';
        $content_table .= '<td><b>'.MODULE_AGI_EXPORT_FEEDS_TEXT_FEED_ACTIVE.'</b><br />'.draw_on_off_selection('agi_feed_status', $options_onoff, $feeds_entry['status']).'<br /><br /></td>';
        $content_table .= '</tr>';
        $content_table .= '<tr>';
        $content_table .= '<td><b>'.MODULE_AGI_EXPORT_FEEDS_PRESELECT_EXPORT_ALLOWED_TITLE.'</b><br />'.MODULE_AGI_EXPORT_FEEDS_PRESELECT_EXPORT_ALLOWED_DESC.'<br />'.draw_on_off_selection('agi_export_allowed', $options_onoff, $feeds_entry['export_allowed']).'<br /><br /></td>';
        $content_table .= '<td><label for="set_export_allowed_on_existing_products"><b>'.MODULE_AGI_EXPORT_FEEDS_PRESELECT_EXPORT_ALLOWED_EXISTING_TITLE.'</b></label><br />'.MODULE_AGI_EXPORT_FEEDS_PRESELECT_EXPORT_ALLOWED_EXISTING_DESC.'<br />'.xtc_draw_checkbox_field('set_export_allowed_on_existing_products', 1, 0, '', 'id="set_export_allowed_on_existing_products"').'<br /><br /></td>';
        $content_table .= '</tr>';
        $content_table .= '<tr>';
        $content_table .= '<td><b>'.MODULE_AGI_EXPORT_FEEDS_TEXT_FEED_NAME.'</b><br />'.MODULE_AGI_EXPORT_FEEDS_TEXT_FEED_NAME_DESC.'<br />'.xtc_draw_input_field('agi_feed_name', $feeds_entry['name'], 'style="width: 250px" maxlength="64"').'<br /><br /></td>';
        $content_table .= '<td><b>'.MODULE_AGI_EXPORT_FEEDS_TEXT_FILENAME.'</b><br />'.MODULE_AGI_EXPORT_FEEDS_TEXT_FEED_FILENAME_DESC.'<br />'.xtc_draw_input_field('agi_feed_file_name', $feeds_entry['file_name'], 'style="width: 250px" maxlength="64"').'<br /><br /></td>';
        $content_table .= '</tr>';
        $content_table .= '<tr>';
        $content_table .= '<td><b>'.MODULE_AGI_EXPORT_FEEDS_TEXT_FEED_CRONCALL.'</b><br />'.MODULE_AGI_EXPORT_FEEDS_TEXT_FEED_CRONCALL_DESC.'<br />'.draw_on_off_selection('agi_feed_cron', $options_onoff, $feeds_entry['cron']).'<br /><br /></td>';
        $content_table .= '<td></td>';
        $content_table .= '</tr>';
        $content_table .= '<tr>';
        $content_table .= '<td colspan="2"><b>'.MODULE_AGI_EXPORT_FEEDS_TEXT_FEED_DESCRIPTION.'</b><br />'.xtc_draw_textarea_field('agi_feed_desc', 'soft', 50, 5, $feeds_entry['description'], 'maxlength="490"').'<br /><br /></td>';
        $content_table .= '<td></td>';
        $content_table .= '</tr>';
        $content_table .= '</table>';
        $contents[] = array('text' => $content_table.'<hr /><br />');
        
        $content_table = '<table id="agi_export_global_export_settings">';
        $content_table .= '<tr>';
        $content_table .= '<td><b>'.MODULE_AGI_EXPORT_FEEDS_TEXT_FEED_LANGUAGE.'</b><br />'.MODULE_AGI_EXPORT_FEEDS_TEXT_FEED_LANGUAGE_DESC.'<br />'.xtc_draw_pull_down_menu('agi_feed_language', $options_feed_languages, $feeds_entry['language']).'<br /><br /></td>';
        $content_table .= '<td><b>'.MODULE_AGI_EXPORT_FEEDS_TEXT_FEED_COUNTRY.'</b><br />'.MODULE_AGI_EXPORT_FEEDS_TEXT_FEED_COUNTRY_DESC.'<br />'.xtc_draw_input_field('agi_feed_country', $feeds_entry['country'], 'style="width: 250px" maxlength="64"').'<br /><br /></td>';
        $content_table .= '</tr>';
        $content_table .= '<tr>';
        $content_table .= '<td><b>'.MODULE_AGI_EXPORT_FEEDS_TEXT_FEED_CGROUP.'</b><br />'.MODULE_AGI_EXPORT_FEEDS_TEXT_FEED_CGROUP_DESC.'<br />'.xtc_draw_pull_down_menu('agi_feed_cgroup', $options_feed_cgroups, $feeds_entry['customers_group']).'<br /><br /></td>';
        $content_table .= '<td><b>'.MODULE_AGI_EXPORT_FEEDS_TEXT_FEED_CURRENCY.'</b><br />'.xtc_draw_pull_down_menu('agi_feed_currency', $options_feed_currencys, $feeds_entry['currency']).'<br /><br /></td>';
        $content_table .= '</tr>';
        $content_table .= '<tr>';
        $content_table .= '<td><b>'.MODULE_AGI_EXPORT_FEEDS_TEXT_FEED_ATTRIBUTES.'</b><br />'.MODULE_AGI_EXPORT_FEEDS_TEXT_FEED_ATTRIBUTES_DESC.'<br />'.draw_on_off_selection('agi_export_attributes', $options_onoff, $feeds_entry['export_attributes']).'<br /><br /></td>';
        $content_table .= '<td><b>'.MODULE_AGI_EXPORT_FEEDS_TEXT_FEED_GRADUATED_PRICE.'</b><br />'.MODULE_AGI_EXPORT_FEEDS_TEXT_FEED_GRADUATED_PRICE_DESC.'<br />'.draw_on_off_selection('agi_export_graduated_price', $options_onoff, $feeds_entry['export_graduated_price']).'<br /><br /></td>';
        $content_table .= '</tr>';
        $content_table .= '</table>';
        $contents[] = array('text' => $content_table.'<hr /><br />');
        
        $products_filter = array();
        if (!empty($feeds_entry['products_filter'])) {
          $tmp = json_decode($feeds_entry['products_filter'], true);
          if (!empty($tmp)) {
            $products_filter = $tmp;
          }
        }
        
        $content_table = MODULE_AGI_EXPORT_FEEDS_TEXT_FILTER_PRODUCTS_TITLE.':';
        $content_table .= '<table class="tableConfig borderall" id="agi_export_feeds_product_filter_table"><tr><th>'.MODULE_AGI_EXPORT_FEEDS_TEXT_FILTER_PARAMETER_TITLE.'</th><th>'.MODULE_AGI_EXPORT_FEEDS_TEXT_FILTER_INPUT_TITLE.'</th><th>'.MODULE_AGI_EXPORT_FEEDS_TEXT_FILTER_DESC_TITLE.'</th></tr>';
        $content_table .= '<tr><td>'.MODULE_AGI_EXPORT_FEEDS_FILTER_ADDPRICE_TITLE.'</td><td>'.xtc_draw_input_field('agi_feed_pfilter[addprice]', !empty($products_filter['addprice']) ?  $products_filter['addprice'] : '', 'style="width: 100px" maxlength="10"').'%</td><td>'.MODULE_AGI_EXPORT_FEEDS_FILTER_ADDPRICE_DESC.'</td></tr>';
        $content_table .= '<tr><td>'.MODULE_AGI_EXPORT_FEEDS_FILTER_MINPRICE_TITLE.'</td><td>'.xtc_draw_input_field('agi_feed_pfilter[minprice]', !empty($products_filter['minprice']) ?  $products_filter['minprice'] : '', 'style="width: 100px" maxlength="10"').'</td><td>'.MODULE_AGI_EXPORT_FEEDS_FILTER_MINPRICE_DESC.'</td></tr>';
        $content_table .= '<tr><td>'.MODULE_AGI_EXPORT_FEEDS_FILTER_MAXPRICE_TITLE.'</td><td>'.xtc_draw_input_field('agi_feed_pfilter[maxprice]', !empty($products_filter['maxprice']) ?  $products_filter['maxprice'] : '', 'style="width: 100px" maxlength="10"').'</td><td>'.MODULE_AGI_EXPORT_FEEDS_FILTER_MAXPRICE_DESC.'</td></tr>';
        $content_table .= '<tr><td>'.MODULE_AGI_EXPORT_FEEDS_FILTER_MINSTOCK_TITLE.'</td><td>'.xtc_draw_input_field('agi_feed_pfilter[minstock]', !empty($products_filter['minstock']) ?  $products_filter['minstock'] : '', 'style="width: 100px" maxlength="10"').'</td><td>'.MODULE_AGI_EXPORT_FEEDS_FILTER_MINSTOCK_DESC.'</td></tr>';
        
        // count manufacturer
        $qr = xtc_db_query("SELECT COUNT(*) AS cnt FROM ".TABLE_MANUFACTURERS);
        $tmp = xtc_db_fetch_array($qr);
        $cnt_manufacturer = $tmp['cnt'];
        $manufacturer_dropdown = array();
        if ($cnt_manufacturer <= 30) {
          $qr = xtc_db_query("SELECT `manufacturers_id`, `manufacturers_name` FROM ".TABLE_MANUFACTURERS." ORDER BY `manufacturers_name`");
          while ($row = xtc_db_fetch_array($qr)) {
            $manufacturer_dropdown[] = array('id' => $row['manufacturers_id'], 'text' => $row['manufacturers_name']);
          }
        }
        $content_table .= '<tr><td>'.MODULE_AGI_EXPORT_FEEDS_FILTER_INLUDE_MANUS_TITLE.'</td><td>';
        if ($cnt_manufacturer <= 30) {
          $tmp = !empty($products_filter['include_manu']) ? explode(',', $products_filter['include_manu']) : array();
          $content_table .= '<table>';
          for ($i=0,$n=$cnt_manufacturer; $i < $n; $i++) {
            $content_table .= '<tr><td><label>'.xtc_draw_checkbox_field('agi_feed_pfilter[include_manu][]', $manufacturer_dropdown[$i]['id'], in_array($manufacturer_dropdown[$i]['id'], $tmp)).' '.encode_htmlentities($manufacturer_dropdown[$i]['text']).'</label></td>';
            if (array_key_exists(($i+1), $manufacturer_dropdown)) {
              $i += 1;
              $content_table .= '<td><label>'.xtc_draw_checkbox_field('agi_feed_pfilter[include_manu][]', $manufacturer_dropdown[$i]['id'], in_array($manufacturer_dropdown[$i]['id'], $tmp)).' '.encode_htmlentities($manufacturer_dropdown[$i]['text']).'</label></td>';
            } else {
              $content_table .= '<td></td>';
            }
            $content_table .= '</tr>';
          }
          $content_table .= '</table>';
        } else {
          $content_table .= xtc_draw_input_field('agi_feed_pfilter[include_manu]', !empty($products_filter['include_manu']) ?  $products_filter['include_manu'] : '', 'style="width: 250px"');
        }
        $content_table .= '</td><td>'.MODULE_AGI_EXPORT_FEEDS_FILTER_INLUDE_MANUS_DESC.'</td></tr>';
        
        $content_table .= '<tr><td>'.MODULE_AGI_EXPORT_FEEDS_FILTER_EXCLUDE_MANUS_TITLE.'</td><td>';
        if ($cnt_manufacturer <= 30) {
          $tmp = !empty($products_filter['exclude_manu']) ? explode(',', $products_filter['exclude_manu']) : array();
          $content_table .= '<table>';
          for ($i=0,$n=$cnt_manufacturer; $i < $n; $i++) {
            $content_table .= '<tr><td><label>'.xtc_draw_checkbox_field('agi_feed_pfilter[exclude_manu][]', $manufacturer_dropdown[$i]['id'], in_array($manufacturer_dropdown[$i]['id'], $tmp)).' '.encode_htmlentities($manufacturer_dropdown[$i]['text']).'</label></td>';
            if (array_key_exists(($i+1), $manufacturer_dropdown)) {
              $i += 1;
              $content_table .= '<td><label>'.xtc_draw_checkbox_field('agi_feed_pfilter[exclude_manu][]', $manufacturer_dropdown[$i]['id'], in_array($manufacturer_dropdown[$i]['id'], $tmp)).' '.encode_htmlentities($manufacturer_dropdown[$i]['text']).'</label></td>';
            } else {
              $content_table .= '<td></td>';
            }
            $content_table .= '</tr>';
          }
          $content_table .= '</table>';
        } else {
          $content_table .= xtc_draw_input_field('agi_feed_pfilter[exclude_manu]', !empty($products_filter['exclude_manu']) ?  $products_filter['exclude_manu'] : '', 'style="width: 250px"');
        }
        $content_table .= '</td><td>'.MODULE_AGI_EXPORT_FEEDS_FILTER_EXCLUDE_MANUS_DESC.'</td></tr>';
        
        
        // count shipping-times
        $qr = xtc_db_query("SELECT COUNT(*) AS cnt FROM ".TABLE_SHIPPING_STATUS." WHERE `language_id`=".$_SESSION['languages_id']);
        $tmp = xtc_db_fetch_array($qr);
        $cnt_shippingtimes = $tmp['cnt'];
        $shippingtimes_dropdown = array();
        if ($cnt_shippingtimes <= 30) {
          $qr = xtc_db_query("SELECT `shipping_status_id`, `shipping_status_name` FROM ".TABLE_SHIPPING_STATUS." WHERE `language_id`=".$_SESSION['languages_id']." ORDER BY `sort_order`,`shipping_status_name`");
          while ($row = xtc_db_fetch_array($qr)) {
            $shippingtimes_dropdown[] = array('id' => $row['shipping_status_id'], 'text' => $row['shipping_status_name']);
          }
        }
        $content_table .= '<tr><td>'.MODULE_AGI_EXPORT_FEEDS_FILTER_INLUDE_STIMES_TITLE.'</td><td>';
        if ($cnt_shippingtimes <= 30) {
          $tmp = !empty($products_filter['include_stimes']) ? explode(',', $products_filter['include_stimes']) : array();
          $content_table .= '<table>';
          for ($i=0,$n=$cnt_shippingtimes; $i < $n; $i++) {
            $content_table .= '<tr><td><label>'.xtc_draw_checkbox_field('agi_feed_pfilter[include_stimes][]', $shippingtimes_dropdown[$i]['id'], in_array($shippingtimes_dropdown[$i]['id'], $tmp)).' '.encode_htmlentities($shippingtimes_dropdown[$i]['text']).'</label></td>';
            if (array_key_exists(($i+1), $shippingtimes_dropdown)) {
              $i += 1;
              $content_table .= '<td><label>'.xtc_draw_checkbox_field('agi_feed_pfilter[include_stimes][]', $shippingtimes_dropdown[$i]['id'], in_array($shippingtimes_dropdown[$i]['id'], $tmp)).' '.encode_htmlentities($shippingtimes_dropdown[$i]['text']).'</label></td>';
            } else {
              $content_table .= '<td></td>';
            }
            $content_table .= '</tr>';
          }
          $content_table .= '</table>';
        } else {
          $content_table .= xtc_draw_input_field('agi_feed_pfilter[include_stimes]', !empty($products_filter['include_stimes']) ?  $products_filter['include_stimes'] : '', 'style="width: 250px"');
        }
        $content_table .= '</td><td>'.MODULE_AGI_EXPORT_FEEDS_FILTER_INLUDE_STIMES_DESC.'</td></tr>';
        
        $content_table .= '<tr><td>'.MODULE_AGI_EXPORT_FEEDS_FILTER_EXCLUDE_STIMES_TITLE.'</td><td>';
        if ($cnt_shippingtimes <= 30) {
          $tmp = !empty($products_filter['exclude_stimes']) ? explode(',', $products_filter['exclude_stimes']) : array();
          $content_table .= '<table>';
          for ($i=0,$n=$cnt_shippingtimes; $i < $n; $i++) {
            $content_table .= '<tr><td><label>'.xtc_draw_checkbox_field('agi_feed_pfilter[exclude_stimes][]', $shippingtimes_dropdown[$i]['id'], in_array($shippingtimes_dropdown[$i]['id'], $tmp)).' '.encode_htmlentities($shippingtimes_dropdown[$i]['text']).'</label></td>';
            if (array_key_exists(($i+1), $shippingtimes_dropdown)) {
              $i += 1;
              $content_table .= '<td><label>'.xtc_draw_checkbox_field('agi_feed_pfilter[exclude_stimes][]', $shippingtimes_dropdown[$i]['id'], in_array($shippingtimes_dropdown[$i]['id'], $tmp)).' '.encode_htmlentities($shippingtimes_dropdown[$i]['text']).'</label></td>';
            } else {
              $content_table .= '<td></td>';
            }
            $content_table .= '</tr>';
          }
          $content_table .= '</table>';
        } else {
          $content_table .= xtc_draw_input_field('agi_feed_pfilter[exclude_stimes]', !empty($products_filter['exclude_stimes']) ?  $products_filter['exclude_stimes'] : '', 'style="width: 250px"');
        }
        $content_table .= '</td><td>'.MODULE_AGI_EXPORT_FEEDS_FILTER_EXCLUDE_STIMES_DESC.'</td></tr>';
        
        $content_table .= '<tr><td>'.MODULE_AGI_EXPORT_FEEDS_FILTER_FSK18_TITLE.'</td><td>'.draw_on_off_selection('agi_feed_pfilter[fsk18]', $options_onoff, !empty($products_filter['fsk18'])).'</td><td>'.MODULE_AGI_EXPORT_FEEDS_FILTER_FSK18_DESC.'</td></tr>';
        $content_table .= '</table>';
        $contents[] = array('text' => $content_table.'<hr /><br />');
        
        $google_setting = array();
        if (!empty($feeds_entry['google_settings'])) {
          $tmp = json_decode($feeds_entry['google_settings'], true);
          if (!empty($tmp)) {
            $google_setting = $tmp;
          }
        }
        $content_table = '<div class="casediv google_xml" style="display:none">'.MODULE_AGI_EXPORT_FEEDS_TEXT_GOOGLE_SETTING.':';
        $content_table .= '<table id="agi_export_feeds_google_setting_table" class="tableConfig borderall"><tr><th>'.MODULE_AGI_EXPORT_FEEDS_TEXT_FILTER_PARAMETER_TITLE.'</th><th width="250">'.MODULE_AGI_EXPORT_FEEDS_TEXT_FILTER_INPUT_TITLE.'</th><th>'.MODULE_AGI_EXPORT_FEEDS_TEXT_FILTER_DESC_TITLE.'</th></tr>';
        $content_table .= '<tr><td>'.MODULE_AGI_EXPORT_FEEDS_TEXT_GOOGLE_SETTING_SHIPPING_TITLE.'</td><td>'.draw_on_off_selection('agi_feed_gsetting[do_shipping]', $options_onoff, array_key_exists('do_shipping', $google_setting) ? ($google_setting['do_shipping']) : 1).'</td><td>'.MODULE_AGI_EXPORT_FEEDS_TEXT_GOOGLE_SETTING_SHIPPING_DESC.'</td></tr>';
        $content_table .= '</table>';
        $contents[] = array('text' => $content_table.'<hr /><br /></div>');
        
        foreach(auto_include(DIR_FS_EXTERNAL.'agi/agi_export/autoinclude/admin/module/feeds_edit/template/','php') as $file) require ($file);
        
        $contents[] = array('text' => '<p class="txta-c"><input type="submit" value="'.BUTTON_SAVE.'" class="button" /><a href="'.xtc_href_link(basename($PHP_SELF), xtc_get_all_get_params(array('action'))).'" class="button">'.BUTTON_CANCEL.'</a></p>');
        
        $box = new box;
        echo $box->infoBox($heading, $contents);
      ?>
      <script>
        $( document ).ready(function() {
          $('#agi_export_feeds_switch_feed_type').on('change', function(){agi_export_feeds_switch_feed_type($(this).val())});
          agi_export_feeds_switch_feed_type($('#agi_export_feeds_switch_feed_type').val());
        });
        function agi_export_feeds_switch_feed_type(value) {
          $('#agi_feed_settings .casediv').hide();
          $('#agi_feed_settings .casediv.'+value).show();
          $('#agi_feed_settings .casediv:hidden input, #agi_feed_settings .casediv:hidden select').attr('disabled',true);
          $('#agi_feed_settings .casediv:visible input, #agi_feed_settings .casediv:visible select').attr('disabled',false);
        }
      </script>
      </div>
    </td>
  </tr>
</table>
<link href="includes/css/module_box_full.css" rel="stylesheet" type="text/css" />
<?php } ?>