<?php
/* includes/external/agi/agi_export/export/classes/agi_shop_config.class.php
.---------------------------------------------------------------------------.
|    Software: agi_export for modified eCommerce                            |
|      Author: Andreas Guder                                                |
|     Contact: info@andreas-guder.de                                        |
| Copyright (c) 2022, Andreas Guder [info@andreas-guder.de]                 |
|               All Rights Reserved.                                        |
| ------------------------------------------------------------------------- |
|     License: you are not allowed to distribute                            |
|              or sublicense copies of the software without                 |
|              a grant of a licence of the coyright-owner                   |
'---------------------------------------------------------------------------ü
*/

class AGI_SHOP_CONFIG
{
  private static $export_conf = array();
  private static $feed_conf = array();
  private static $language_id = 2;
  private static $language_directory = 'german';
  private static $country_id  = 0;
  private static $customers_group = 1;
  private static $language_code = 'de';
  private static $language_charset = 'ISO-8859-15';
  private static $country_code  = 'DE';
  private static $shipping_countries_code  = 'DE';
  private static $zone_id   = 0;
  private static $utf8_shop = false;
  private static $default_google_category = '';
  private static $currency_to_link = false;
  
  /* Arrays */
  private static $currency = array();
  private static $ignor_vpe_values = array();
  private static $assing_vpe_values= array();
  private static $assign_words_gender = array('male'=>array(),'female'=>array(),'unisex'=>array());
  private static $assign_words_age_group = array('kids'=>array(),'adult'=>array(),'newborn'=>array(),'infant'=>array(),'toddler'=>array());
  private static $shop_categories = array();
  private static $shipping_status_name = array();
  private static $manufacturer    = array();
  private static $shipping_value_table = array();
  private static $country_shipping_value_table = array();
  private static $more_countries_ship_to = array();
  private static $vpe_data       = array();
  private static $customers_permissions = array();
  private static $tax_rates      = array();
  private static $ignore_google_attributes = array();
  
  private static $google_attribute_options = array();
  private static $google_attribute_options_ids = array();
  private static $google_attribute_options_ids_name = array();
  
  private static $attribut_export_limit = 0;
  private static $export_campaign = '';
  
  private static $activate_free_amount_module = false;
  private static $value_free_amount_module = 0;
  private static $add_price_percent = 0;
  
  public function __construct($_agi_export_config, $_feed_config)
  {
    
    self::$export_conf = $_agi_export_config;
    self::$feed_conf = $_feed_config;
    self::$utf8_shop = $_agi_export_config['is_utf8_shop'] ? true : false;
    $export_language = self::$feed_conf['language'];
    $customers_group = self::$feed_conf['customers_group'];
    
    $q = xtDBquery("SELECT * FROM `" . TABLE_LANGUAGES . "` WHERE `languages_id`=$export_language");
    $q_result = xtc_db_fetch_array($q, true);
    if ($q_result) {
      self::$language_id = $q_result['languages_id'];
      self::$language_code = strtolower($q_result['code']);
      self::$language_charset = strtoupper($q_result['language_charset']);
      self::$language_directory = strtolower($q_result['directory']);
    }
    /*
    if ($_feed_config['type'] == 'google_xml') {
      self::$language_charset == 'UTF-8';
    } else {
      if (!empty($_feed_config['csv_settings'])) {
        self::$language_charset = $_feed_config['csv_settings']['charset'];
      }
    }
    */
    $_SESSION['language_charset'] = self::$language_charset;
    include_once DIR_FS_CATALOG.'lang/'.self::$language_directory.'/modules/order_total/ot_shipping.php';
    defined('MODULE_ORDER_TOTAL_SHIPPING_TITLE') OR define('MODULE_ORDER_TOTAL_SHIPPING_TITLE','Standard');
    defined('FREE_SHIPPING_TITLE') OR define('FREE_SHIPPING_TITLE','Versandkostenfrei');
    
    // get customers_status
    $c_check = xtDBquery("SELECT * FROM `".TABLE_CUSTOMERS_STATUS."` WHERE `customers_status_id`=$customers_group AND `language_id`=$export_language");
    if (xtc_db_num_rows($c_check, true) == 0) {
      $c_check = xtDBquery("SELECT * FROM `".TABLE_CUSTOMERS_STATUS."` WHERE `customers_status_id`=1 AND `language_id`=1");
    }
    self::$customers_permissions = xtc_db_fetch_array($c_check, true);
    self::$customers_group = self::$customers_permissions['customers_status_id'];
    
    // load country-code
    $country = self::$feed_conf['country'];
    if (preg_match('/^[A-Za-z,]{2,}$/',$country)) {
      $tmp_country = explode(',', $country);
      self::$country_code = $tmp_country[0];
      self::$shipping_countries_code = $country;
      $query = xtDBquery("SELECT `countries_id` FROM `".TABLE_COUNTRIES."` WHERE `countries_iso_code_2`='".self::$country_code."' LIMIT 0,1");
      $tmp = xtc_db_fetch_array($query, true);
      if (!empty($tmp)) {
        self::$country_id   = $tmp['countries_id'];
      } else {
        $country = '';
      }
    }
    if (empty($country)) {
      $query = xtDBquery("SELECT `countries_iso_code_2` FROM `".TABLE_COUNTRIES."` WHERE `countries_id`=".STORE_COUNTRY." LIMIT 0,1");
      $tmp = xtc_db_fetch_array($query, true);
      self::$country_code = self::$shipping_countries_code = $country = $tmp['countries_iso_code_2'];
      self::$country_id   = STORE_COUNTRY;
    }
    // load shop-zone
    $tmp = xtc_db_query("SELECT `zone_id` FROM `".TABLE_ZONES."` WHERE `zone_country_id`=".self::$country_id." LIMIT 0,1");
    $tmp = xtc_db_fetch_array($tmp);
    self::$zone_id = $tmp['zone_id'];

    // load currency-information
    self::$currency = array('SYMBOL_LEFT'=>'', 'SYMBOL_RIGHT'=>'', 'DECIMAL_POINT'=>'', 'THOUSANDS_POINT'=>'', 'DECIMAL_PLACES'=>2, 'VALUE'=>1, 'CODE'=>'');
    $query = xtDBquery("SELECT * FROM `".TABLE_CURRENCIES."` WHERE `currencies_id`='".self::$feed_conf['currency']."' LIMIT 0,1");
    $tmp = xtc_db_fetch_array($query, true);
    if (empty($tmp)) {
      $query = xtDBquery("SELECT * FROM `".TABLE_CURRENCIES."` WHERE `code`='".DEFAULT_CURRENCY."' LIMIT 0,1");
      $tmp = xtc_db_fetch_array($query, true);
    }
    if (!empty($tmp)) {
      self::$currency = array(
        'SYMBOL_LEFT'     => $tmp['symbol_left'],
        'SYMBOL_RIGHT'    => $tmp['symbol_right'],
        'DECIMAL_POINT'   => $tmp['decimal_point'],
        'THOUSANDS_POINT' => $tmp['thousands_point'],
        'DECIMAL_PLACES'  => $tmp['decimal_places'],
        'VALUE'           => $tmp['value'],
        'CODE'            => $tmp['code']
      );
    }
    if (strtolower(DEFAULT_CURRENCY) != strtolower(self::$currency['CODE']) && !empty(self::$currency['CODE'])) {
      self::$currency_to_link = true;
    }
    
    $this->prepare_language_containing_constants();
    if (!AGI_EXPORT_QUICK) {
      self::$shop_categories[0] = array('parent'=>0, 'name'=>'Top', 'google'=>self::$default_google_category, 'name_html'=>str_replace('&', '&amp;', self::$default_google_category));
      // load shop_categories
      $q = "SELECT c.categories_id, c.parent_id, cd.categories_name, cd.agi_google_category FROM
        `" . TABLE_CATEGORIES . "` AS c
        LEFT JOIN `" . TABLE_CATEGORIES_DESCRIPTION . "` AS cd ON cd.categories_id=c.categories_id AND cd.language_id=".self::$language_id;
      $q_result = xtDBquery($q);
      while ($row = xtc_db_fetch_array($q_result, true)) {
        self::$shop_categories[$row['categories_id']] = array(
          'parent'    => $row['parent_id'], 
          'name'      => $row['categories_name'], 
          'name_html' => str_replace('&', '&amp;', $row['categories_name']),
          'google'    => $row['agi_google_category']
        );
      }
    }
    // load shipping-status-names
    $q = "SELECT `shipping_status_id` AS data_id, `shipping_status_name` AS data_name FROM `" . TABLE_SHIPPING_STATUS . "` WHERE `language_id`=".self::$language_id;
    self::$shipping_status_name = $this->load_db_table_fields($q);
    
    // load vpe-names
    $q = "SELECT `products_vpe_id`, `products_vpe_name` FROM `" . TABLE_PRODUCTS_VPE . "` WHERE `language_id`=".self::$language_id;
    $result = array();
    $q_result = xtDBquery($q);
    while ($row = xtc_db_fetch_array($q_result, true)) {
      $t = $this->explode_vpe_parts($row['products_vpe_name']);
      self::$vpe_data[$row['products_vpe_id']] = array('name'=>$row['products_vpe_name'], 'unit'=>$t['unit'], 'value'=>$t['value']);
    }
    
    if (!AGI_EXPORT_QUICK) {
      // load manufacturers name
      $q = "SELECT `manufacturers_id` AS data_id, `manufacturers_name` AS data_name FROM `".TABLE_MANUFACTURERS."`";
      self::$manufacturer = $this->load_db_table_fields($q);
    }
      
    // load google_attributes
    $q = "SELECT `products_options_id`, `agi_export_google_attribut` FROM `".TABLE_PRODUCTS_OPTIONS."` WHERE `language_id` = ".self::$language_id." AND `agi_export_google_attribut` != ''";
    $q_result = xtDBquery($q);
    while ($row = xtc_db_fetch_array($q_result, true)) {
      if (!array_key_exists($row['agi_export_google_attribut'], self::$google_attribute_options_ids_name)) {
        self::$google_attribute_options_ids_name[$row['agi_export_google_attribut']] = array();
      }
      self::$google_attribute_options_ids_name[$row['agi_export_google_attribut']][] = $row['products_options_id'];
      self::$google_attribute_options_ids[] = $row['products_options_id'];
      self::$google_attribute_options[$row['products_options_id']] = $row['agi_export_google_attribut'];
    }
    
    $t = trim($_agi_export_config['shipping_table']);
    if (!empty($t)) {
      // default-countries shipping-table
      $shippingTable = array();
      $tex = explode(';', $t);
      foreach ($tex as $row) {
        $tmp = explode('::', $row);
        if (count($tmp) == 2) {
          if (strtolower($tmp[0]) == strtolower(self::$country_code)) {
            $shippingTable = preg_split("/[:,]/" , $tmp[1]);
            break;
          }
        }
        elseif (count($tmp) == 1) {
          $shippingTable = preg_split("/[:,]/" , $tmp[0]);
          break;
        }
      }
      if (empty($shippingTable)) {
        $tmp = explode('::', $tex[0]);
        if (count($tmp) == 2) {
          $shippingTable = preg_split("/[:,]/" , $tmp[1]);
        }
        elseif (count($tmp) == 1) {
          $shippingTable = preg_split("/[:,]/" , $tmp[0]);
        }
        else {
          $shippingTable = array();
        }
      }
      self::$shipping_value_table = $shippingTable;
      
      // all-countries shipping-table
      foreach ($tex as $row) {
        $tmp = explode('::', $row);
        if (count($tmp) == 2) {
          $shippingTable = preg_split("/[:,]/" , $tmp[1]);
          self::$country_shipping_value_table[$tmp[0]] = $shippingTable;
        }
      }
    } else {
      self::$shipping_value_table = array();
    }
    // more countries ship to
    $tmp = explode(',', self::$shipping_countries_code);
    foreach ($tmp as $value) {
      if ($value != self::$country_code) {
        self::$more_countries_ship_to[] = $value;
      }
    }
    
    if (!AGI_EXPORT_QUICK) {
      /* Kampagnen */
      if (!empty(self::$feed_conf['campaign'])) {
        $q = "SELECT `campaigns_uripams` FROM `agi_export_cmp_addlink` WHERE `campaigns_id` = '".self::$feed_conf['campaign']."'";
        $q_result = xtDBquery($q);
        $tmp = xtc_db_fetch_array($q_result, true);
        if ($tmp) {
          $t1 = substr($tmp['campaigns_uripams'], 0,1);
          if ($t1 == '&' || $t1 == '?') {
            self::$export_campaign = mb_substr($tmp['campaigns_uripams'],1);
          } else {
            self::$export_campaign = $tmp['campaigns_uripams'];
          }
        }
      }
    }
    
    /* Free-Amount */
    if (defined('MODULE_SHIPPING_FREEAMOUNT_STATUS') && strtolower(MODULE_SHIPPING_FREEAMOUNT_STATUS) == 'true' ) {
      if (!defined('MODULE_SHIPPING_FREEAMOUNT_NUMBER_ZONES')) {
        if (MODULE_SHIPPING_FREEAMOUNT_ALLOWED == '' || strpos(MODULE_SHIPPING_FREEAMOUNT_ALLOWED, self::$country_code) !== FALSE) {
          self::$activate_free_amount_module = true;
          self::$value_free_amount_module = MODULE_SHIPPING_FREEAMOUNT_AMOUNT;
        }
      }
      else {
        $found_zone = 0;
        $found_value = 0;
        for ($i=1; $i<=MODULE_SHIPPING_FREEAMOUNT_NUMBER_ZONES; $i++) {
          $countries_table = constant('MODULE_SHIPPING_FREEAMOUNT_COUNTRIES_' . $i);
          $countries_table  = preg_replace("'[\r\n\s]+'",'',$countries_table);
          if ($countries_table != 'WORLD') {
            $country_zones = explode(',', $countries_table);
            if (in_array(self::$country_code, $country_zones)) {
              $found_zone = $i;
              $found_value = constant('MODULE_SHIPPING_FREEAMOUNT_AMOUNT_'.$i);
              break;
            }
          }
          else {
            $found_zone = $i;
            $found_value = constant('MODULE_SHIPPING_FREEAMOUNT_AMOUNT_'.$i);
            break;
          }
        }
        if ($found_zone > 0) {
          self::$activate_free_amount_module = true;
          self::$value_free_amount_module = $found_value;
        }
      }
    }
    if (defined('MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER') && strtolower(MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING) == 'true' && !self::$activate_free_amount_module) {
      if (strtolower(MODULE_ORDER_TOTAL_SHIPPING_DESTINATION) == 'both') {
        self::$activate_free_amount_module = true;
        self::$value_free_amount_module = MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER_INTERNATIONAL < MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER ? MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER_INTERNATIONAL : MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER;
      }
      elseif (strtolower(MODULE_ORDER_TOTAL_SHIPPING_DESTINATION) == 'national' && self::$country_id == STORE_COUNTRY) {
        self::$activate_free_amount_module = true;
        self::$value_free_amount_module = MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER;
      }
      elseif (strtolower(MODULE_ORDER_TOTAL_SHIPPING_DESTINATION) == 'international' && self::$country_id != STORE_COUNTRY) {
        self::$activate_free_amount_module = true;
        self::$value_free_amount_module = MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER_INTERNATIONAL;
      }
    }
    
    if (!empty(self::$export_conf['attributes_limit_amount'])) {
      self::$attribut_export_limit = preg_match('/^[0-9]+$/', self::$export_conf['attributes_limit_amount']) ? self::$export_conf['attributes_limit_amount'] : 1000;
    }
    if (array_key_exists('products_filter', self::$feed_conf)) {
      $tmp = self::$feed_conf['products_filter'];
      if (is_array($tmp) && !empty($tmp)) {
        if (array_key_exists('addprice', $tmp) && !empty($tmp['addprice'])) {
          if (preg_match('/^\-?\d+(\.\d+)?$/', $tmp['addprice'])) {
            self::$add_price_percent = (float)$tmp['addprice'];
          }
        }
      }
    }
  }
  
  /**
   * constructor called function
   */
  private function prepare_language_containing_constants()
  {
    $t = $this->split_language_containing_string(self::$export_conf['google_default_category'], true);
    self::$default_google_category = !empty($t) ? current($t) : '';
    
    self::$assign_words_gender['male']      = $this->split_language_containing_string(self::$export_conf['gender_words_male']);
    self::$assign_words_gender['female']    = $this->split_language_containing_string(self::$export_conf['gender_words_female']);
    self::$assign_words_gender['unisex']    = $this->split_language_containing_string(self::$export_conf['gender_words_unisex']);
    self::$assign_words_age_group['kids']   = $this->split_language_containing_string(self::$export_conf['group_words_kids']);
    self::$assign_words_age_group['adult']  = $this->split_language_containing_string(self::$export_conf['group_words_adult']);
    self::$assign_words_age_group['newborn']= $this->split_language_containing_string(self::$export_conf['group_words_newborn']);
    self::$assign_words_age_group['infant'] = $this->split_language_containing_string(self::$export_conf['group_words_infant']);
    self::$assign_words_age_group['toddler']= $this->split_language_containing_string(self::$export_conf['group_words_toddler']);
    $t = $this->split_language_containing_string(self::$export_conf['ignore_vpe_values']);
    foreach ($t as $key => $value) {
      self::$ignor_vpe_values[$key] = mb_strtolower($value, self::$utf8_shop ? 'UTF-8' : $_SESSION['language_charset']);
    }
    
    $t = $this->split_language_containing_string(self::$export_conf['map_vpe_values']);
    $t_result = array();
    foreach ($t as $row) {
      $t1 = explode('=', $row);
      if (count($t1) == 2) {
        $t2 = array();
        foreach ($t1 as $key => $value) {
          $t2[$key] = trim($value);
        }
        $t1 = $t2;
        $t_result[mb_strtolower($t1[0], self::$utf8_shop ? 'UTF-8' : $_SESSION['language_charset'])] = $t1[1];
      }
    }
    self::$assing_vpe_values = $t_result;
  }
  
  /**
   * constructor called function
   * @param string $q
   * @return array();
   */
  private function load_db_table_fields($q = '')
  {
    if (empty($q)) {
      return array();
    }
    $result = array();
    $q_result = xtDBquery($q);
    while ($row = xtc_db_fetch_array($q_result, true)) {
      $result[$row['data_id']] = $row['data_name'];
    }
    return $result;
  }
  
  private function explode_vpe_parts($vpe_text)
  {
    $vpe_parts = array('value' => 1, 'unit' => '');
    if (preg_match('/^[0-9]{1,}/', $vpe_text, $matches)) {
      $vpe_parts['value'] = $matches[0];
      $vpe_parts['unit'] = trim(mb_substr($vpe_text, mb_strlen($vpe_parts['value'])));
    }
    else
      $vpe_parts['unit'] = trim($vpe_text);
    settype($vpe_parts['value'], 'integer');
    return $vpe_parts;
  }
  
  /**
   * @param string eq: 2stelligerSprachcode:Wert1,Wert2;2stelligerSprachcode:Wert1,Wert2
   * @return array with values for export-language
   */
  private function split_language_containing_string($string, $ignore_komma = false)
  {
    if (empty($string)) {
      return array();
    }
    $string = decode_htmlentities(trim($string), ENT_COMPAT, self::$utf8_shop ? 'UTF-8' : $_SESSION['language_charset']);
    
    $l_array = explode(';', $string);
    $all_results = array();
    $l_data = array();
    foreach ($l_array as $l_row) {
      $l_row = trim($l_row);
      if (mb_strpos($l_row, ':') !== FALSE) {
        $t = explode(':', $l_row);
        $l_data[strtolower(trim($t[0]))] = trim($t[1]);
      }
      else {
        $l_data[self::$language_code] = $l_row;
      }
    }
    
    foreach ($l_data as $l_code => $l_values) {
      if (!$ignore_komma) {
        $t = explode(',', $l_values);
        $t2 = array();
        foreach ($t as $key => $value) {
          $t2[$key] = trim($value);
        }
        $t = $t2;
      }
      else {
        $t = array($l_values);
      }
      $all_results[$l_code] = $t;
    }
    if (empty($all_results)) {
      return array();
    }
    else {
      return array_key_exists(self::$language_code, $all_results) ? $all_results[self::$language_code] : current($all_results);
    }
  }
  
  public static function get_language_id()
  {
    return self::$language_id;
  }
  public static function get_country_id()
  {
    return self::$country_id;
  }
  public static function get_zone_id()
  {
    return self::$zone_id;
  }
  public static function get_customers_group()
  {
    return self::$customers_group;
  }
  public static function get_language_code()
  {
    return self::$language_code;
  }
  public static function get_language_directory()
  {
    return self::$language_directory;
  }
  public static function get_country_code()
  {
    return self::$country_code;
  }
  public static function get_default_google_category()
  {
    return self::$default_google_category;
  }
  public static function get_shop_categories()
  {
    return self::$shop_categories;
  }
  public static function get_shipping_value_table($country = '')
  {
    if (!empty($country) && array_key_exists($country, self::$country_shipping_value_table)) {
      return self::$country_shipping_value_table[$country];
    }
    return self::$shipping_value_table;
  }
  public static function get_country_shipping_list()
  {
    return self::$more_countries_ship_to;
  }
  public static function get_google_attribute_options()
  {
    return self::$google_attribute_options;
  }
  public static function get_google_attribute_options_ids()
  {
    return self::$google_attribute_options_ids;
  }
  public static function get_google_attribute_options_ids_name()
  {
    return self::$google_attribute_options_ids_name;
  }
  public static function get_tax_rate($tax_id)
  {
    settype($tax_id, 'int');
    if (!array_key_exists($tax_id, self::$tax_rates)) {
      self::$tax_rates[$tax_id] = xtc_get_tax_rate($tax_id, self::$country_id, self::$zone_id);
    }
    return self::$tax_rates[$tax_id];
  }
  public static function get_google_shipping_status($sID = 0)
  {
    settype($sID, 'int');
    $result = '';
    if (array_key_exists($sID, self::$export_conf['map_shipping_to_status'])) {
      $result = !empty(self::$export_conf['map_shipping_to_status'][$sID]) ? self::$export_conf['map_shipping_to_status'][$sID] : '';
    }
    return empty($result) ? 'in stock' : $result;
  }
  public static function get_shipping_status_name($sID = 0)
  {
    settype($sID, 'int');
    $result = '';
    if (array_key_exists($sID, self::$shipping_status_name)) {
      $result = !empty(self::$shipping_status_name[$sID]) ? self::$shipping_status_name[$sID] : '';
    }
    return empty($result) ? '' : $result;
  }
  
  public static function get_manufacturers_name($mID = 0)
  {
    settype($mID, 'int');
    $result = '';
    if (array_key_exists($mID, self::$manufacturer)) {
      $result = !empty(self::$manufacturer[$mID]) ? self::$manufacturer[$mID] : '';
    }
    return $result;
  }
  public static function get_categories_data($cID = 0)
  {
    settype($cID, 'int');
    $result = array('name'=>'', 'path'=>'', 'path_html'=>'', 'google'=>'');
    if (array_key_exists($cID, self::$shop_categories)) {
      $result['name']   = self::$shop_categories[$cID]['name'];
      $result['google'] = self::$shop_categories[$cID]['google'];
      $t_path = array(self::$shop_categories[$cID]['name']);
      $t_path_html = array(self::$shop_categories[$cID]['name_html']);
      $next = self::$shop_categories[$cID]['parent'];
      while ($next > 0) {
        $t_path[] = self::$shop_categories[$next]['name'];
        $t_path_html[] = self::$shop_categories[$next]['name_html'];
        if (empty($result['google'])) {
          $result['google'] = self::$shop_categories[$next]['google'];
        }
        $next = self::$shop_categories[$next]['parent'];
      }
      $t_path = array_reverse($t_path);
      $t_path_html = array_reverse($t_path_html);
      $result['path'] = implode(' > ', $t_path);
      $result['path_html'] = implode(' > ', $t_path_html);
    }
    return $result;
  }
  public static function get_currency_value($value)
  {
    return array_key_exists($value, self::$currency) ? self::$currency[$value] : null;
  }
  public static function get_vpe_data($vID = 0, $field = 'name')
  {
    settype($vID, 'int');
    if (!in_array($field, array('name', 'unit', 'value'))) {
      return false;
    }
    $result = array();
    if (array_key_exists($vID, self::$vpe_data)) {
      $result = !empty(self::$vpe_data[$vID]) ? self::$vpe_data[$vID] : array();
    }
    return empty($result) ? '' : $result[$field];
  }
  public static function is_utf8_shop()
  {
    return self::$utf8_shop;
  }
  public static function is_currency_to_url()
  {
    return self::$currency_to_link;
  }
  public static function is_ignored_vpe_unit($value)
  {
    return in_array(strtolower($value), self::$ignor_vpe_values) ? true : false;
  }
  public static function is_assigned_word($assign_to = 'gender', $field, $word)
  {
    if (empty($word)) {
      return false;
    }
    switch ($assign_to) {
      case 'gender':
        $assign_array = self::$assign_words_gender;
        break;
      case 'age_group':
        $assign_array = self::$assign_words_age_group;
        break;
      default:
        return false;
    }
    if (!array_key_exists($field, $assign_array)) {
      return false;
    }
    return in_array(mb_strtolower($word), $assign_array[$field]) ? true : false;
  }
  public static function replace_vpe_unit($unit = '')
  {
    return array_key_exists(mb_strtolower($unit), self::$assing_vpe_values) ? self::$assing_vpe_values[mb_strtolower($unit)] : $unit;
  }
  public static function get_customers_permissions($field)
  {
    return array_key_exists($field, self::$customers_permissions) ? self::$customers_permissions[$field] : '';
  }
  public static function get_google_attribute_option($value)
  {
    return array_key_exists($value, self::$google_attribute_options) ? self::$google_attribute_options[$value] : '';
  }
  
  public static function set_google_attribute_options($value)
  {
    if (!empty($value)) {
      self::$google_attribute_options[$value] = $value;
    }
  }
  public static function calculate_price($price = 0, $format = 1, $calc_currency = true)
  {
    if ($calc_currency) {
      $price *= self::get_currency_value('VALUE');
    }
    $price = round($price,2);
    if ($format == 1) {
      $string = '';
      $string .= number_format(
        $price, 
        self::get_currency_value('DECIMAL_PLACES'), 
        self::get_currency_value('DECIMAL_POINT'), 
        (isset($_GET['noTP']) && $_GET['noTP'] == 1) ? '' : self::get_currency_value('THOUSANDS_POINT')
      );
      if (self::get_currency_value('CODE') != '') {
        $string .= ' '.self::get_currency_value('CODE');
      }
      $price = $string;
    } elseif ($format == 2) {
      $string = '';
      $string .= number_format(
        $price, 
        self::get_currency_value('DECIMAL_PLACES'), 
        '.', 
        ''
      );
      if (self::get_currency_value('CODE') != '') {
        $string .= ' '.self::get_currency_value('CODE');
      }
      $price = $string;
    }
    return $price;
  }
  public static function add_tax($price, $tax) 
	{ 
	  $price=$price+$price/100*$tax;
	  return $price;
  }
  public static function is_attribut_limit()
  {
    return self::$attribut_export_limit;
  }
  // Kampagnen
  public static function get_campaign()
  {
    return self::$export_campaign;
  }
  // freeamount
  public static function is_active_free_amount_module() 
  {
    return self::$activate_free_amount_module;
  }
  public static function get_free_amount_value() 
  {
    return self::$value_free_amount_module;
  }
  public static function get_add_price_percent() 
  {
    return self::$add_price_percent;
  }
  public static function get_agi_export_conf($key = '')
  {
    if (empty($key)) {
      return self::$export_conf;
    }
    if (array_key_exists($key, self::$export_conf)) {
      if (!empty(self::$export_conf[$key])) {
        return substr(self::$export_conf[$key], 0, 1) == '{' ? json_decode(self::$export_conf[$key], true) : self::$export_conf[$key];
      } else {
        return self::$export_conf[$key];
      }
    }
    return '';
  }
  public static function get_agi_feed_conf($key = '')
  {
    if (empty($key)) {
      return self::$feed_conf;
    }
    if (array_key_exists($key, self::$feed_conf)) {
      if (!empty(self::$feed_conf[$key])) {
        return in_array(substr(self::$feed_conf[$key], 0, 1), array('{','[')) ? json_decode(self::$feed_conf[$key], true) : self::$feed_conf[$key];
      } else {
        return self::$feed_conf[$key];
      }
    }
    return '';
  }

}
